






#ifndef Anf_Koord_3Et_H
#define Anf_Koord_3Et_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum Anf_Koord_3EtStatusEnum {
st_Efz_001_000_Anf_Koord_3Et, // Zustand 001 als Efz Operation 000
st_Efz_002_002_Anf_Koord_3Et, // Zustand 002 als Efz Operation 002
st_Efz_003_003_Anf_Koord_3Et, // Zustand 003 als Efz Operation 003
st_Efz_004_005_Anf_Koord_3Et, // Zustand 004 als Efz Operation 005
st_Efz_005_006_Anf_Koord_3Et, // Zustand 005 als Efz Operation 006
st_Efz_006_008_Anf_Koord_3Et, // Zustand 006 als Efz Operation 008
st_Efz_007_009_Anf_Koord_3Et, // Zustand 007 als Efz Operation 009
st_Efz_008_015_Anf_Koord_3Et, // Zustand 008 als Efz Operation 015
st_Efz_009_016_Anf_Koord_3Et, // Zustand 009 als Efz Operation 016
st_Efz_010_017_Anf_Koord_3Et // Zustand 010 als Efz Operation 017
};

enum Anf_Koord_3EtOperationEnum {
op_none_Anf_Koord_3Et // Keine Operation
};


struct Anf_Koord_3EtData {
// Input
BOOL Anf_Et1_aufw:1; // Anforderung von Etage 1 aufwrts
BOOL Anf_Et2_abw:1; // Anforderung von Etage 2 abwrts
BOOL Anf_Et2_aufw:1; // Anforderung von Etage 2 aufwrts
BOOL Anf_Et3_abw:1; // Anforderung von Etage 3 abwrts
BOOL Kab_In_1:1; // Kabine in\n Etage 1
BOOL Kab_In_2:1; // Kabine in\n Etage 2
BOOL Kab_In_3:1; // Kabine in\n Etage 3
BOOL Kab_Nach1:1; // Kabine nach\n Etage 1
BOOL Kab_Nach2:1; // Kabine nach\n Etage 2
BOOL Kab_Nach3:1; // Kabine nach\n Etage 3
BOOL NOTHALT_Oeffner:1; // KEIN\n NOT-HALT
TON WarteTimer; // Timer Variable Initiation
// Output
BOOL Kab_abw_fahren:1; // Kabine abwrts
BOOL Kab_aufw_fahren:1; // Kabine aufwrts
BOOL KabiNach_1_abw:1; // Kabine nach 1 abwrts
BOOL KabiNach_2_abw:1; // Kabine nach 2 abwrts
BOOL KabiNach_2_auf:1; // Kabine nach 2 aufwrts
BOOL KabiNach_3_auf:1; // Kabine nach 3 aufwrts
BOOL Meldg_Stop_Fehler:1; // Meldung: Lift zwischen Etagen
// Input and Output
BOOL FirstRun:1; // Variable sets Start State
// Local
BOOL EndWart:1; // Ende Warten
BOOL WZ:1; // Wartezeit
enum Anf_Koord_3EtStatusEnum StatusEnum; // 
enum Anf_Koord_3EtOperationEnum OperationEnum; // 
BOOL FirstRun:1; // Erstlaufkennung
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class Anf_Koord_3Et{
public:
Anf_Koord_3Et();
~Anf_Koord_3Et();
void Init();
void Run();
struct Anf_Koord_3EtData Data;
};
extern IOPLC ioplc;
#endif

