#ifndef FahrAnforderung_H
#define FahrAnforderung_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum FahrAnforderungStatusEnum {
st_Efz_001_000_FahrAnforderung, // Zustand 001 als Efz Operation 000
st_Efz_002_001_FahrAnforderung // Zustand 002 als Efz Operation 001
};

enum FahrAnforderungOperationEnum {
op_none_FahrAnforderung // Keine Operation
};


struct FahrAnforderungData {
// Input
BOOL FahrtGegenrichtung:1; // Fahrt in Gegenrichtung
BOOL KabAnSollPos:1; // Kabine an Rufposition?
BOOL RufEtage:1; // Ruftaste in .. bettigt
// Output
BOOL AnfVon_InRichtg:1; // Anf_von_inRichtg
BOOL Sign_Lamp_ein:1; // Signallampe ein
// Input and Output
BOOL FirstRun:1; // Variable sets Start State
// Local
enum FahrAnforderungStatusEnum StatusEnum; // 
enum FahrAnforderungOperationEnum OperationEnum; // 
BOOL FirstRun:1; // Erstlaufkennung
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class FahrAnforderung{
public:
FahrAnforderung();
~FahrAnforderung();
void Init();
void Run();
struct FahrAnforderungData Data;
};
extern IOPLC ioplc;
#endif

