






#include "Anf_Koord_3Et.h"

// Constants
const INT Const_st_Efz_001_000 = 0; // Zustand 001 als Efz Operation 000
const INT Const_st_Efz_002_002 = 2; // Zustand 002 als Efz Operation 002
const INT Const_st_Efz_003_003 = 3; // Zustand 003 als Efz Operation 003
const INT Const_st_Efz_004_005 = 5; // Zustand 004 als Efz Operation 005
const INT Const_st_Efz_005_006 = 6; // Zustand 005 als Efz Operation 006
const INT Const_st_Efz_006_008 = 8; // Zustand 006 als Efz Operation 008
const INT Const_st_Efz_007_009 = 9; // Zustand 007 als Efz Operation 009
const INT Const_st_Efz_008_015 = 15; // Zustand 008 als Efz Operation 015
const INT Const_st_Efz_009_016 = 16; // Zustand 009 als Efz Operation 016
const INT Const_st_Efz_010_017 = 17; // Zustand 010 als Efz Operation 017
const TIME WarteZeit = 2000; // Timer Value Initiation

void Anf_Koord_3Et_cold_start(struct Anf_Koord_3EtData *Data){
Data->Anf_Et1_aufw = false;
Data->Anf_Et2_abw = false;
Data->Anf_Et2_aufw = false;
Data->Anf_Et3_abw = false;
Data->Et2_langs = false;
Data->Kab_In_1 = false;
Data->Kab_In_2 = false;
Data->Kab_In_3 = false;
Data->Kab_Nach1 = false;
Data->Kab_Nach2 = false;
Data->Kab_Nach3 = false;
Data->NOTHALT_Oeffner = false;
Data->Kab_abw_fahren = false;
Data->Kab_aufw_fahren = false;
Data->KabiNach_1_abw = false;
Data->KabiNach_2_abw = false;
Data->KabiNach_2_auf = false;
Data->KabiNach_3_auf = false;
Data->Meldg_Stop_Fehler = false;
Data->FirstRun = false;
Data->EndWart = false;
Data->WZ = false;
Data->FirstRun = true;
Data->StatusEnum = 0;
Data->OperationEnum = 0;
Data->OldOperationINT = 0;
Data->OperationINT = 0;
}

void Anf_Koord_3Et(struct Anf_Koord_3EtData *Data){

	Data->EndWart=Data->WarteTimer.Q;
	Data->OldOperationINT=Data->OperationINT;
		// Set the initial state
	if (Data->FirstRun){	// First run variable
		Data->FirstRun = false;
		Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
		Data->OperationEnum = op_none_Anf_Koord_3Et;
	} else {	// If FirstRun=True then output of initial operation.
			// The state machine
		Data->OperationEnum = op_none_Anf_Koord_3Et;
		switch (Data->StatusEnum) {
			case st_Efz_001_000_Anf_Koord_3Et :	// Zustand 001 als Efz Operation 000
				
				if (	    Data->Kab_In_3
					&& !Data->Kab_In_2
					&& !Data->Kab_In_1
					&&  Data->EndWart
					&&  Data->NOTHALT_Oeffner
					&& (	    Data->Anf_Et1_aufw
						||  Data->Kab_Nach1
					)
				){
					Data->StatusEnum = st_Efz_006_008_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Kab_Nach1
					&& !Data->Anf_Et1_aufw
					&&  Data->Kab_In_3
					&& !Data->Kab_In_2
					&& !Data->Kab_In_1
					&&  Data->EndWart
					&&  Data->NOTHALT_Oeffner
					&& (	    Data->Kab_Nach2
						||  Data->Anf_Et2_abw
						||  Data->Anf_Et2_aufw
					)
				){
					Data->StatusEnum = st_Efz_007_009_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	    Data->NOTHALT_Oeffner
					&&  Data->EndWart
					&& !Data->Kab_In_1
					&& !Data->Kab_In_2
					&& !Data->Kab_In_3
				){
					Data->StatusEnum = st_Efz_008_015_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	    Data->Kab_In_2
					&& !Data->Kab_In_1
					&&  Data->EndWart
					&&  Data->NOTHALT_Oeffner
					&& (	    Data->Kab_Nach3
						||  Data->Anf_Et3_abw
					)
				){
					Data->StatusEnum = st_Efz_004_005_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Anf_Et3_abw
					&& !Data->Kab_Nach3
					&&  Data->Kab_In_2
					&& !Data->Kab_In_1
					&&  Data->EndWart
					&&  Data->NOTHALT_Oeffner
					&& (	    Data->Kab_Nach1
						||  Data->Anf_Et1_aufw
					)
				){
					Data->StatusEnum = st_Efz_005_006_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	    Data->Kab_In_1
					&&  Data->EndWart
					&&  Data->NOTHALT_Oeffner
					&& (	    Data->Anf_Et3_abw
						||  Data->Kab_Nach3
					)
				){
					Data->StatusEnum = st_Efz_002_002_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Anf_Et3_abw
					&& !Data->Kab_Nach3
					&&  Data->Kab_In_1
					&&  Data->EndWart
					&&  Data->NOTHALT_Oeffner
					&& (	    Data->Anf_Et2_aufw
						||  Data->Kab_Nach2
						||  Data->Anf_Et2_abw
					)
				){
					Data->StatusEnum = st_Efz_003_003_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_002_002_Anf_Koord_3Et :	// Zustand 002 als Efz Operation 002
				
				if (	   !Data->Anf_Et2_aufw
					&& (	   !Data->NOTHALT_Oeffner
						||  Data->Kab_Nach2
					)
					|| (	    Data->Anf_Et2_aufw
					)
				){
					Data->StatusEnum = st_Efz_003_003_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Anf_Et2_aufw
					&& !Data->Kab_Nach2
					&&  Data->NOTHALT_Oeffner
					&&  Data->Et2_langs
				){
					Data->StatusEnum = st_Efz_009_016_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_003_003_Anf_Koord_3Et :	// Zustand 003 als Efz Operation 003
				
				if (	    Data->Kab_In_2
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_004_005_Anf_Koord_3Et :	// Zustand 004 als Efz Operation 005
				
				if (	    Data->Kab_In_3
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_005_006_Anf_Koord_3Et :	// Zustand 005 als Efz Operation 006
				
				if (	    Data->Kab_In_1
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_006_008_Anf_Koord_3Et :	// Zustand 006 als Efz Operation 008
				
				if (	   !Data->Kab_Nach2
					&& (	   !Data->NOTHALT_Oeffner
						||  Data->Anf_Et2_abw
					)
					|| (	    Data->Kab_Nach2
					)
				){
					Data->StatusEnum = st_Efz_007_009_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Kab_Nach2
					&& !Data->Anf_Et2_abw
					&&  Data->NOTHALT_Oeffner
					&&  Data->Et2_langs
				){
					Data->StatusEnum = st_Efz_010_017_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_007_009_Anf_Koord_3Et :	// Zustand 007 als Efz Operation 009
				
				if (	    Data->Kab_In_2
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_008_015_Anf_Koord_3Et :	// Zustand 008 als Efz Operation 015
				
				if (	    Data->Kab_In_3
					&& !Data->Kab_In_2
					&& !Data->Kab_In_1
					&& (	    Data->Anf_Et1_aufw
						||  Data->Kab_Nach1
					)
				){
					Data->StatusEnum = st_Efz_006_008_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Kab_Nach1
					&& !Data->Anf_Et1_aufw
					&&  Data->Kab_In_3
					&& !Data->Kab_In_2
					&& !Data->Kab_In_1
					&& (	    Data->Kab_Nach2
						||  Data->Anf_Et2_abw
						||  Data->Anf_Et2_aufw
					)
				){
					Data->StatusEnum = st_Efz_007_009_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Kab_Nach1
					&& !Data->Anf_Et1_aufw
					&& !Data->Kab_In_1
					&& (	   !Data->Kab_In_2
						&&  Data->Kab_In_3
						&& !Data->Anf_Et2_aufw
						&& !Data->Kab_Nach2
						&& !Data->Anf_Et2_abw
						|| (	    Data->Kab_In_2
							&& !Data->Kab_Nach3
							&& !Data->Anf_Et3_abw
						)
					)
					|| (	    Data->Kab_In_1
						&& !Data->Kab_Nach3
						&& !Data->Anf_Et3_abw
						&& !Data->Anf_Et2_aufw
						&& !Data->Kab_Nach2
						&& !Data->Anf_Et2_abw
					)
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	    Data->Kab_In_2
					&& !Data->Kab_In_1
					&& (	    Data->Kab_Nach3
						||  Data->Anf_Et3_abw
					)
				){
					Data->StatusEnum = st_Efz_004_005_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Anf_Et3_abw
					&& !Data->Kab_Nach3
					&&  Data->Kab_In_2
					&& !Data->Kab_In_1
					&& (	    Data->Kab_Nach1
						||  Data->Anf_Et1_aufw
					)
				){
					Data->StatusEnum = st_Efz_005_006_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	    Data->Kab_In_1
					&& (	    Data->Anf_Et3_abw
						||  Data->Kab_Nach3
					)
				){
					Data->StatusEnum = st_Efz_002_002_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
				if (	   !Data->Anf_Et3_abw
					&& !Data->Kab_Nach3
					&&  Data->Kab_In_1
					&& (	    Data->Anf_Et2_aufw
						||  Data->Kab_Nach2
						||  Data->Anf_Et2_abw
					)
				){
					Data->StatusEnum = st_Efz_003_003_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_009_016_Anf_Koord_3Et :	// Zustand 009 als Efz Operation 016
				
				if (	    Data->Kab_In_3
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
			case st_Efz_010_017_Anf_Koord_3Et :	// Zustand 010 als Efz Operation 017
				
				if (	    Data->Kab_In_1
				){
					Data->StatusEnum = st_Efz_001_000_Anf_Koord_3Et;
					Data->OperationEnum = op_none_Anf_Koord_3Et;
				}
			break;
		}	// End switch Data->StatusEnum
	}	// End First Run
		// The Output List
	Data->WZ = (
		    (Data->StatusEnum == st_Efz_001_000_Anf_Koord_3Et)
	);
	Data->KabiNach_2_auf = (
		    (Data->StatusEnum == st_Efz_003_003_Anf_Koord_3Et)
	);
	Data->KabiNach_2_abw = (
		    (Data->StatusEnum == st_Efz_007_009_Anf_Koord_3Et)
	);
	Data->Meldg_Stop_Fehler = (
		    (Data->StatusEnum == st_Efz_008_015_Anf_Koord_3Et)
	);
	Data->KabiNach_3_auf = (
		    (Data->StatusEnum == st_Efz_002_002_Anf_Koord_3Et)
		||  (Data->StatusEnum == st_Efz_004_005_Anf_Koord_3Et)
		||  (Data->StatusEnum == st_Efz_009_016_Anf_Koord_3Et)
	);
	Data->KabiNach_1_abw = (
		    (Data->StatusEnum == st_Efz_005_006_Anf_Koord_3Et)
		||  (Data->StatusEnum == st_Efz_006_008_Anf_Koord_3Et)
		||  (Data->StatusEnum == st_Efz_010_017_Anf_Koord_3Et)
	);
	Data->Kab_aufw_fahren = (
		    Data->KabiNach_3_auf
		||  (Data->StatusEnum == st_Efz_003_003_Anf_Koord_3Et)
	);
	Data->Kab_abw_fahren = (
		    Data->KabiNach_1_abw
		||  (Data->StatusEnum == st_Efz_007_009_Anf_Koord_3Et)
	);
		// The post-state-machine List
	 Data->WarteTimer.IN = Data->WZ;
	 Data->WarteTimer.PT = WarteZeit;
	TON(&Data->WarteTimer);
		if (Data->StatusEnum==st_Efz_001_000_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_001_000;
		}
		if (Data->StatusEnum==st_Efz_002_002_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_002_002;
		}
		if (Data->StatusEnum==st_Efz_003_003_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_003_003;
		}
		if (Data->StatusEnum==st_Efz_004_005_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_004_005;
		}
		if (Data->StatusEnum==st_Efz_005_006_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_005_006;
		}
		if (Data->StatusEnum==st_Efz_006_008_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_006_008;
		}
		if (Data->StatusEnum==st_Efz_007_009_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_007_009;
		}
		if (Data->StatusEnum==st_Efz_008_015_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_008_015;
		}
		if (Data->StatusEnum==st_Efz_009_016_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_009_016;
		}
		if (Data->StatusEnum==st_Efz_010_017_Anf_Koord_3Et){
			Data->OperationINT=Const_st_Efz_010_017;
		}
		

}


