
#ifndef AntriebKab_TuerKoord_H
#define AntriebKab_TuerKoord_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum AntriebKab_TuerKoordStatusEnum {
st_Efz_001_000_AntriebKab_TuerKoord, // Zustand 001 als Efz Operation 000
st_Efz_002_001_AntriebKab_TuerKoord, // Zustand 002 als Efz Operation 001
st_Efz_003_002_AntriebKab_TuerKoord, // Zustand 003 als Efz Operation 002
st_Efz_004_003_AntriebKab_TuerKoord, // Zustand 004 als Efz Operation 003
st_Efz_005_004_AntriebKab_TuerKoord, // Zustand 005 als Efz Operation 004
st_Efz_006_005_AntriebKab_TuerKoord, // Zustand 006 als Efz Operation 005
st_Efz_007_008_AntriebKab_TuerKoord, // Zustand 007 als Efz Operation 008
st_Efz_008_009_AntriebKab_TuerKoord, // Zustand 008 als Efz Operation 009
st_Efz_009_010_AntriebKab_TuerKoord // Zustand 009 als Efz Operation 010
};

enum AntriebKab_TuerKoordOperationEnum {
op_none_AntriebKab_TuerKoord // Keine Operation
};


struct AntriebKab_TuerKoordData {
// Input
BOOL Autom:1; // Automatikbetrieb
BOOL Heb_Hand:1; // Handbetrieb\n aufwrts
BOOL KabFahrt_abw:1; // Kabine fhrt\n abwrts
BOOL KabFahrt_aufw:1; // Kabine fhrt\n aufwrts
BOOL Lift_ABW_ein:1; // Fahrt\n abwrts
BOOL Lift_AUFW_ein:1; // Fahrt\n aufwrts
BOOL Nothalt_OEFFNER:1; // KEIN\n NOT-HALT
BOOL Senk_Hand:1; // Handbetrieb\n abwrts
BOOL Tuer_istauf:1; // Tre\n geffnet
BOOL Tueren_sindzu:1; // Tren\n geschlossen
// Output
BOOL KabNICHTabw:1; // Kabine fhrt nicht abwrts
BOOL KabNICHTaufw:1; // Kabine fhrt nicht aufwrts
BOOL KabNachOben:1; // Kabinenmotor nach oben EIN
BOOL KabNachUnten:1; // Kabine nach unten EIN
BOOL TuerOeffnen:1; // Tr soll geffnet werden
BOOL TuerSchliessen:1; // Tr soll geschlossen werden
// Input and Output
BOOL FirstRun:1; // Variable sets Start State
// Local
BOOL AnfDauerEnd:1; // Anfahrdauer\n beendet
BOOL StartAnlTimer:1; // Anlauf-Timer starten
BOOL FirstRun:1; // First run variable
TON AnlTimer; // Fahrtrichtung - Anlauftimer
enum AntriebKab_TuerKoordStatusEnum StatusEnum; // 
enum AntriebKab_TuerKoordOperationEnum OperationEnum; // 
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class AntriebKab_TuerKoord{
public:
AntriebKab_TuerKoord();
~AntriebKab_TuerKoord();
void Init();
void Run();
struct AntriebKab_TuerKoordData Data;
};
extern IOPLC ioplc;
#endif

