
#include "EtagenAnzeige.h"

// Constants
const INT Const_st_Efz_001_000 = 0; // Zustand 001 als Efz Operation 000
const INT Const_st_Efz_002_001 = 1; // Zustand 002 als Efz Operation 001
const INT Const_st_Efz_003_002 = 2; // Zustand 003 als Efz Operation 002

void EtagenAnzeige_cold_start(struct EtagenAnzeigeData *Data){
Data->Kab_In1 = false;
Data->Kab_In2 = false;
Data->Kab_In3 = false;
Data->SegA = false;
Data->SegB = false;
Data->SegC = false;
Data->SegD = false;
Data->SegE = false;
Data->SegG = false;
Data->StatusEnum = 0;
Data->OperationEnum = 0;
Data->FirstRun = true;
Data->OldOperationINT = 0;
Data->OperationINT = 0;
}

void EtagenAnzeige(struct EtagenAnzeigeData *Data){

	Data->OldOperationINT=Data->OperationINT;
		// Set the initial state
	if (Data->FirstRun){	// First run variable
		Data->FirstRun = false;
		Data->StatusEnum = st_Efz_001_000_EtagenAnzeige;
		Data->OperationEnum = op_none_EtagenAnzeige;
	} else {	// If FirstRun=True then output of initial operation.
			// The state machine
		Data->OperationEnum = op_none_EtagenAnzeige;
		switch (Data->StatusEnum) {
			case st_Efz_001_000_EtagenAnzeige :	// Zustand 001 als Efz Operation 000
				
				if (	   !Data->Kab_In2
					&&  Data->Kab_In3
				){
					Data->StatusEnum = st_Efz_003_002_EtagenAnzeige;
					Data->OperationEnum = op_none_EtagenAnzeige;
				}
				if (	    Data->Kab_In2
				){
					Data->StatusEnum = st_Efz_002_001_EtagenAnzeige;
					Data->OperationEnum = op_none_EtagenAnzeige;
				}
			break;
			case st_Efz_002_001_EtagenAnzeige :	// Zustand 002 als Efz Operation 001
				
				if (	   !Data->Kab_In3
					&&  Data->Kab_In1
				){
					Data->StatusEnum = st_Efz_001_000_EtagenAnzeige;
					Data->OperationEnum = op_none_EtagenAnzeige;
				}
				if (	    Data->Kab_In3
				){
					Data->StatusEnum = st_Efz_003_002_EtagenAnzeige;
					Data->OperationEnum = op_none_EtagenAnzeige;
				}
			break;
			case st_Efz_003_002_EtagenAnzeige :	// Zustand 003 als Efz Operation 002
				
				if (	    Data->Kab_In2
					&& !Data->Kab_In1
				){
					Data->StatusEnum = st_Efz_002_001_EtagenAnzeige;
					Data->OperationEnum = op_none_EtagenAnzeige;
				}
				if (	    Data->Kab_In2
					&&  Data->Kab_In1
				){
					Data->StatusEnum = st_Efz_001_000_EtagenAnzeige;
					Data->OperationEnum = op_none_EtagenAnzeige;
				}
			break;
		}	// End switch Data->StatusEnum
	}	// End First Run
		// The Output List
	Data->SegE = (
		    (Data->StatusEnum == st_Efz_002_001_EtagenAnzeige)
	);
	Data->SegA = (
		    (Data->StatusEnum == st_Efz_002_001_EtagenAnzeige)
		||  (Data->StatusEnum == st_Efz_003_002_EtagenAnzeige)
	);
	Data->SegC = (
		    (Data->StatusEnum == st_Efz_001_000_EtagenAnzeige)
		||  (Data->StatusEnum == st_Efz_003_002_EtagenAnzeige)
	);
	Data->SegD = (
		    Data->SegA
	);
	Data->SegG = (
		    Data->SegD
	);
	Data->SegB = (
		    Data->SegG
		||  (Data->StatusEnum == st_Efz_001_000_EtagenAnzeige)
	);
		// The post-state-machine List
	if (Data->StatusEnum==st_Efz_001_000_EtagenAnzeige){
		Data->OperationINT=Const_st_Efz_001_000;
	}
	if (Data->StatusEnum==st_Efz_002_001_EtagenAnzeige){
		Data->OperationINT=Const_st_Efz_002_001;
	}
	if (Data->StatusEnum==st_Efz_003_002_EtagenAnzeige){
		Data->OperationINT=Const_st_Efz_003_002;
	}
	

}


