
#include "FahrAnforderung.h"

// Constants
const INT Const_st_Efz_001_000 = 0; // Zustand 001 als Efz Operation 000
const INT Const_st_Efz_002_001 = 1; // Zustand 002 als Efz Operation 001

FahrAnforderung::FahrAnforderung(){
Data.KabAnSollPos = false;
Data.RufEtage = false;
Data.FahrtGegenRichtung = false;
Data.AnfVon_InRichtg = false;
Data.Sign_Lamp_ein = false;
Data.FirstRun = false;
Data.StatusEnum = (FahrAnforderungStatusEnum)0;
Data.OperationEnum = (FahrAnforderungOperationEnum)0;
Data.FirstRun = true;
Data.OldOperationINT = 0;
Data.OperationINT = 0;
Init();
};

FahrAnforderung::~FahrAnforderung(){
};

void FahrAnforderung::Init(){
Data.FirstRun = ;
};

void FahrAnforderung::Run(){

	Data.OldOperationINT=Data.OperationINT;
		// Set the initial state
	if (Data.FirstRun){	// First run variable
		Data.FirstRun = false;
		Data.StatusEnum = st_Efz_001_000_FahrAnforderung;
		Data.OperationEnum = op_none_FahrAnforderung;
	} else {	// If FirstRun=True then output of initial operation.
			// The state machine
		Data.OperationEnum = op_none_FahrAnforderung;
		switch (Data.StatusEnum) {
			case st_Efz_001_000_FahrAnforderung :	// Zustand 001 als Efz Operation 000
				
				if (	    Data.RufEtage
				){
					Data.StatusEnum = st_Efz_002_001_FahrAnforderung;
					Data.OperationEnum = op_none_FahrAnforderung;
				}
			break;
			case st_Efz_002_001_FahrAnforderung :	// Zustand 002 als Efz Operation 001
				
				if (	    Data.KabAnSollPos
					&& !Data.FahrtGegenRichtung
					&& !Data.RufEtage
				){
					Data.StatusEnum = st_Efz_001_000_FahrAnforderung;
					Data.OperationEnum = op_none_FahrAnforderung;
				}
			break;
		}	// End switch Data.StatusEnum
	}	// End First Run
		// The Output List
	Data.Sign_Lamp_ein = (
		    (Data.StatusEnum == st_Efz_002_001_FahrAnforderung)
	);
	Data.AnfVon_InRichtg = 	// KOP nach Anforderungs-Koordinierung
		(
		    (Data.StatusEnum == st_Efz_002_001_FahrAnforderung)
	);
		// The post-state-machine List
	if (Data.StatusEnum==st_Efz_001_000_FahrAnforderung){
		Data.OperationINT=Const_st_Efz_001_000;
	}
	if (Data.StatusEnum==st_Efz_002_001_FahrAnforderung){
		Data.OperationINT=Const_st_Efz_002_001;
	}
	

}


