
#ifndef Tuer_Position_H
#define Tuer_Position_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum Tuer_PositionStatusEnum {
st_Mfz_001_Tuer_Position // Zustand 001 als Mfz
};

enum Tuer_PositionOperationEnum {
op_none_Tuer_Position, // Keine Operation
op_1_000_Tuer_Position, // Operation 000 in Mfz 1
op_1_001_Tuer_Position, // Operation 001 in Mfz 1
op_1_002_Tuer_Position // Operation 002 in Mfz 1
};


struct Tuer_PositionData {
// Input
BOOL Tuer_1_geoeffn:1; // Tr 1 geffnet
BOOL Tuer_1_geschl:1; // Tr 1 geschlossen
BOOL Tuer_2_geoeffn:1; // Tr 2 geffnet
BOOL Tuer_2_geschl:1; // Tr 2 geschlossen
BOOL Tuer_3_geoeffn:1; // Tr 3 geffnet
BOOL Tuer_3_geschl:1; // Tr 3 geschlossen
// Output
BOOL Tueren_Geschl:1; // Tren geschlossen
BOOL eineTuer_offen:1; // Eine Tr geffnet
// Input and Output
BOOL FirstRun:1; // Variable sets Start State
// Local
enum Tuer_PositionStatusEnum StatusEnum; // 
enum Tuer_PositionOperationEnum OperationEnum; // 
BOOL FirstRun:1; // First run variable
BOOL AVOR:1; // Avor Marke
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class Tuer_Position{
public:
Tuer_Position();
~Tuer_Position();
void Init();
void Run();
struct Tuer_PositionData Data;
};
extern IOPLC ioplc;
#endif

