
#include "Tuerstrg.h"

// Constants
const INT Const_op_1_000 = 0; // Operation 000 in Mfz 1
const INT Const_op_1_001 = 1; // Operation 001 in Mfz 1
const INT Const_op_1_002 = 2; // Operation 002 in Mfz 1
const INT Const_op_1_003 = 3; // Operation 003 in Mfz 1

Tuerstrg::Tuerstrg(){
Data.ZielErr = false;
Data.SollTuerOeff = false;
Data.SollTuerSchl = false;
Data.TuerGeoeffn = false;
Data.TuerGeschl = false;
Data.Automat = false;
Data.TuerOeffVHd = false;
Data.TuerSchlVHd = false;
Data.TuerOeff_EIN = false;
Data.TuerSchli_EIN = false;
Data.StatusEnum = (TuerstrgStatusEnum)0;
Data.OperationEnum = (TuerstrgOperationEnum)0;
Data.FirstRun = true;
Data.AVOR = false;
Data.OldOperationINT = 0;
Data.OperationINT = 0;
Init();
};

Tuerstrg::~Tuerstrg(){
};

void Tuerstrg::Init(){
Data.FirstRun = true;
};

void Tuerstrg::Run(){

	Data.OldOperationINT=Data.OperationINT;
		// Set the initial operation
	if (Data.FirstRun){	// First run variable
		Data.FirstRun = false;
		Data.StatusEnum = st_Mfz_001_Tuerstrg;
		Data.OperationEnum = op_1_000_Tuerstrg;
	} else {	// If FirstRun=True then output of initial operation.
		if (	   !Data.SollTuerOeff
			&&  Data.Automat
			&&  Data.ZielErr
			&& (	    Data.TuerGeschl
				|| !Data.SollTuerSchl
			)
			|| (	   !Data.TuerOeffVHd
				&& !Data.Automat
				&&  Data.ZielErr
				&& (	   !Data.TuerSchlVHd
					||  Data.TuerGeschl
				)
			)
			|| (	   !Data.ZielErr
			)
		){
			Data.OperationEnum = op_1_000_Tuerstrg;
		}
		if (	   !Data.TuerGeschl
			&&  Data.ZielErr
			&& (	    Data.Automat
				&& !Data.SollTuerOeff
				&&  Data.SollTuerSchl
				|| (	   !Data.Automat
					&& !Data.TuerOeffVHd
					&&  Data.TuerSchlVHd
				)
			)
		){
			Data.OperationEnum = op_1_003_Tuerstrg;
		}
		if (	    Data.TuerGeoeffn
			&&  Data.ZielErr
			&& (	    Data.Automat
				&&  Data.SollTuerOeff
				|| (	   !Data.Automat
					&&  Data.TuerOeffVHd
				)
			)
		){
			Data.OperationEnum = op_1_001_Tuerstrg;
		}
		if (	   !Data.TuerGeoeffn
			&&  Data.ZielErr
			&& (	    Data.Automat
				&&  Data.SollTuerOeff
				|| (	   !Data.Automat
					&&  Data.TuerOeffVHd
				)
			)
		){
			Data.OperationEnum = op_1_002_Tuerstrg;
		}
	}	// End First Run
		// The Output List
	Data.TuerOeff_EIN = (
		    (Data.OperationEnum == op_1_002_Tuerstrg)
	);
	Data.TuerSchli_EIN = (
		    (Data.OperationEnum == op_1_003_Tuerstrg)
	);
		// The post-state-machine List
	if (Data.OperationEnum==op_1_000_Tuerstrg){
		Data.OperationINT=Const_op_1_000;
	}
	if (Data.OperationEnum==op_1_001_Tuerstrg){
		Data.OperationINT=Const_op_1_001;
	}
	if (Data.OperationEnum==op_1_002_Tuerstrg){
		Data.OperationINT=Const_op_1_002;
	}
	if (Data.OperationEnum==op_1_003_Tuerstrg){
		Data.OperationINT=Const_op_1_003;
	}
	

}


