
#include "AntriebKab_TuerKoord.h"

// Constants
const TIME AnlZeit = 200; // Timer Value Initiation
const INT Const_st_Efz_001_000 = 0; // Zustand 001 als Efz Operation 000
const INT Const_st_Efz_002_001 = 1; // Zustand 002 als Efz Operation 001
const INT Const_st_Efz_003_002 = 2; // Zustand 003 als Efz Operation 002
const INT Const_st_Efz_004_003 = 3; // Zustand 004 als Efz Operation 003
const INT Const_st_Efz_005_004 = 4; // Zustand 005 als Efz Operation 004
const INT Const_st_Efz_006_005 = 5; // Zustand 006 als Efz Operation 005
const INT Const_st_Efz_007_008 = 8; // Zustand 007 als Efz Operation 008
const INT Const_st_Efz_008_009 = 9; // Zustand 008 als Efz Operation 009
const INT Const_st_Efz_009_010 = 10; // Zustand 009 als Efz Operation 010

AntriebKab_TuerKoord::AntriebKab_TuerKoord(){
Data.Lift_AUFW_ein = false;
Data.Lift_ABW_ein = false;
Data.Tuer_istauf = false;
Data.Tueren_sindzu = false;
Data.Nothalt_OEFFNER = false;
Data.KabFahrt_aufw = false;
Data.KabFahrt_abw = false;
Data.Heb_Hand = false;
Data.Senk_Hand = false;
Data.Autom = false;
Data.KabNachOben = false;
Data.KabNachUnten = false;
Data.TuerOeffnen = false;
Data.TuerSchliessen = false;
Data.KabNICHTaufw = false;
Data.KabNICHTabw = false;
Data.AnfDauerEnd = false;
Data.StartAnlTimer = false;
Data.FirstRun = true;
Data.StatusEnum = (AntriebKab_TuerKoordStatusEnum)0;
Data.OperationEnum = (AntriebKab_TuerKoordOperationEnum)0;
Data.OldOperationINT = 0;
Data.OperationINT = 0;
Init();
};

AntriebKab_TuerKoord::~AntriebKab_TuerKoord(){
};

void AntriebKab_TuerKoord::Init(){
Data.FirstRun = True;
};

void AntriebKab_TuerKoord::Run(){

		// The pre-state-machine List
	Data.AnfDauerEnd=Data.AnlTimer.Data.Q;
	Data.OldOperationINT=Data.OperationINT;
		// Set the initial state
	if (Data.FirstRun){	// Sets the initial state
		Data.FirstRun = false;
		Data.StatusEnum = st_Efz_001_000_AntriebKab_TuerKoord;
		Data.OperationEnum = op_none_AntriebKab_TuerKoord;
	} else {	// If FirstRun=True then output of initial operation.
			// The state machine
		Data.OperationEnum = op_none_AntriebKab_TuerKoord;
		switch (Data.StatusEnum) {
			case st_Efz_001_000_AntriebKab_TuerKoord :	// Zustand 001 als Efz Operation 000
				
				if (	    Data.Nothalt_OEFFNER
					&&  Data.Lift_AUFW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_002_001_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	    Data.Nothalt_OEFFNER
					&& !Data.Lift_AUFW_ein	// KOP von Anford_Koord
					&&  Data.Lift_ABW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_005_004_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_002_001_AntriebKab_TuerKoord :	// Zustand 002 als Efz Operation 001
				
				if (	    Data.Nothalt_OEFFNER
					&& !Data.Tueren_sindzu
					&& !Data.Lift_AUFW_ein	// KOP von Anford_Koord
					&&  Data.Lift_ABW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_005_004_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	    Data.Nothalt_OEFFNER
					&& !Data.Tueren_sindzu
					&& !Data.Lift_AUFW_ein	// KOP von Anford_Koord
					&& !Data.Lift_ABW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_001_000_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	    Data.Nothalt_OEFFNER
					&&  Data.Tueren_sindzu
				){
					Data.StatusEnum = st_Efz_003_002_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	   !Data.Nothalt_OEFFNER
				){
					Data.StatusEnum = st_Efz_004_003_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_003_002_AntriebKab_TuerKoord :	// Zustand 003 als Efz Operation 002
				
				if (	   !Data.Lift_AUFW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_004_003_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	    Data.Lift_AUFW_ein	// KOP von Anford_Koord
					&&  Data.AnfDauerEnd
					&& !Data.KabFahrt_aufw	// Kop von EchteFahrt
				){
					Data.StatusEnum = st_Efz_007_008_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_004_003_AntriebKab_TuerKoord :	// Zustand 004 als Efz Operation 003
				
				if (	    Data.Tuer_istauf
				){
					Data.StatusEnum = st_Efz_001_000_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_005_004_AntriebKab_TuerKoord :	// Zustand 005 als Efz Operation 004
				
				if (	    Data.Nothalt_OEFFNER
					&& !Data.Tueren_sindzu
					&& !Data.Lift_ABW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_001_000_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	    Data.Nothalt_OEFFNER
					&&  Data.Tueren_sindzu
				){
					Data.StatusEnum = st_Efz_006_005_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	   !Data.Nothalt_OEFFNER
				){
					Data.StatusEnum = st_Efz_004_003_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_006_005_AntriebKab_TuerKoord :	// Zustand 006 als Efz Operation 005
				
				if (	   !Data.Lift_ABW_ein	// KOP von Anford_Koord
				){
					Data.StatusEnum = st_Efz_004_003_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
				if (	    Data.Lift_ABW_ein	// KOP von Anford_Koord
					&&  Data.AnfDauerEnd
					&& !Data.KabFahrt_abw
				){
					Data.StatusEnum = st_Efz_008_009_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_007_008_AntriebKab_TuerKoord :	// Zustand 007 als Efz Operation 008
				
				if (	   !Data.Autom
					&&  Data.Heb_Hand
				){
					Data.StatusEnum = st_Efz_009_010_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_008_009_AntriebKab_TuerKoord :	// Zustand 008 als Efz Operation 009
				
				if (	   !Data.Autom
					&&  Data.Senk_Hand
				){
					Data.StatusEnum = st_Efz_009_010_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
			case st_Efz_009_010_AntriebKab_TuerKoord :	// Zustand 009 als Efz Operation 010
				
				if (	    Data.Autom
				){
					Data.StatusEnum = st_Efz_001_000_AntriebKab_TuerKoord;
					Data.OperationEnum = op_none_AntriebKab_TuerKoord;
				}
			break;
		}	// End switch Data.StatusEnum
	}	// End First Run
		// The Output List
	Data.KabNachOben = (
		    (Data.StatusEnum == st_Efz_003_002_AntriebKab_TuerKoord)
	);
	Data.TuerOeffnen = 	// KOP nach Tuerstrg
		(
		    (Data.StatusEnum == st_Efz_004_003_AntriebKab_TuerKoord)
	);
	Data.KabNachUnten = (
		    (Data.StatusEnum == st_Efz_006_005_AntriebKab_TuerKoord)
	);
	Data.KabNICHTaufw = (
		    (Data.StatusEnum == st_Efz_007_008_AntriebKab_TuerKoord)
	);
	Data.KabNICHTabw = (
		    (Data.StatusEnum == st_Efz_008_009_AntriebKab_TuerKoord)
	);
	Data.TuerSchliessen = 	// KOP nach Tuerstrg
		(
		    (Data.StatusEnum == st_Efz_002_001_AntriebKab_TuerKoord)
		||  (Data.StatusEnum == st_Efz_005_004_AntriebKab_TuerKoord)
	);
	Data.StartAnlTimer = (
		    (Data.StatusEnum == st_Efz_003_002_AntriebKab_TuerKoord)
		||  (Data.StatusEnum == st_Efz_006_005_AntriebKab_TuerKoord)
	);
		// The post-state-machine List
	 Data.AnlTimer.Data.IN = Data.StartAnlTimer;
	 Data.AnlTimer.Data.PT = AnlZeit;
	Data.AnlTimer.Run();
	
	if (Data.StatusEnum==st_Efz_001_000_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_001_000;
	}
	if (Data.StatusEnum==st_Efz_002_001_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_002_001;
	}
	if (Data.StatusEnum==st_Efz_003_002_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_003_002;
	}
	if (Data.StatusEnum==st_Efz_004_003_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_004_003;
	}
	if (Data.StatusEnum==st_Efz_005_004_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_005_004;
	}
	if (Data.StatusEnum==st_Efz_006_005_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_006_005;
	}
	if (Data.StatusEnum==st_Efz_007_008_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_007_008;
	}
	if (Data.StatusEnum==st_Efz_008_009_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_008_009;
	}
	if (Data.StatusEnum==st_Efz_009_010_AntriebKab_TuerKoord){
		Data.OperationINT=Const_st_Efz_009_010;
	}
	

}


