#ifndef EtagenAnzeige_H
#define EtagenAnzeige_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum EtagenAnzeigeStatusEnum {
st_Efz_001_000_EtagenAnzeige, // Zustand 001 als Efz Operation 000
st_Efz_002_001_EtagenAnzeige, // Zustand 002 als Efz Operation 001
st_Efz_003_002_EtagenAnzeige // Zustand 003 als Efz Operation 002
};

enum EtagenAnzeigeOperationEnum {
op_none_EtagenAnzeige // Keine Operation
};


struct EtagenAnzeigeData {
// Input
BOOL Kab_In1:1; // Kabine ist\n in Etage 1
BOOL Kab_In2:1; // Kabine ist\n in Etage 2
BOOL Kab_In3:1; // Kabine ist\n in Etage 3
// Output
BOOL SegA:1; // Segment A EIN
BOOL SegB:1; // Segment B EIN
BOOL SegC:1; // Segment C EIN
BOOL SegD:1; // Segment D EIN
BOOL SegG:1; // Segment G EIN
BOOL SegE:1; // Segment E EIN
// Local
BOOL FirstRun:1; // Sets the initial state
enum EtagenAnzeigeStatusEnum StatusEnum; // 
enum EtagenAnzeigeOperationEnum OperationEnum; // 
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class EtagenAnzeige{
public:
EtagenAnzeige();
~EtagenAnzeige();
void Init();
void Run();
struct EtagenAnzeigeData Data;
};
extern IOPLC ioplc;
#endif

