
#ifndef FahrAnforderung_H
#define FahrAnforderung_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum FahrAnforderungStatusEnum {
st_Efz_001_000_FahrAnforderung, // Zustand 001 als Efz Operation 000
st_Efz_002_001_FahrAnforderung // Zustand 002 als Efz Operation 001
};

enum FahrAnforderungOperationEnum {
op_none_FahrAnforderung // Keine Operation
};


struct FahrAnforderungData {
// Input
BOOL RufEtage:1; // Ruftaste in .. bettigt
BOOL KabAnSollPos:1; // Kabine an Rufposition?
// Output
BOOL Sign_Lamp_ein:1; // Signallampe ein
BOOL AnfVon_InRichtg:1; // Anf von x in y-Richtung
// Local
BOOL FirstRun:1; // Sets the initial state
enum FahrAnforderungStatusEnum StatusEnum; // 
enum FahrAnforderungOperationEnum OperationEnum; // 
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class FahrAnforderung{
public:
FahrAnforderung();
~FahrAnforderung();
void Init();
void Run();
struct FahrAnforderungData Data;
};
extern IOPLC ioplc;
#endif

