
#include "FahrtRichtung.h"

// Constants
const INT Const_st_Efz_001_000 = 0; // Zustand 001 als Efz Operation 000
const INT Const_st_Efz_002_001 = 1; // Zustand 002 als Efz Operation 001
const INT Const_st_Efz_003_002 = 2; // Zustand 003 als Efz Operation 002
const INT Const_st_Efz_004_003 = 3; // Zustand 004 als Efz Operation 003

FahrtRichtung::FahrtRichtung(){
Data.SignA = false;
Data.SignB = false;
Data.mul = false;
Data.edul = false;
Data.FirstRun = true;
Data.StatusEnum = (FahrtRichtungStatusEnum)0;
Data.OperationEnum = (FahrtRichtungOperationEnum)0;
Data.OldOperationINT = 0;
Data.OperationINT = 0;
Init();
};

FahrtRichtung::~FahrtRichtung(){
};

void FahrtRichtung::Init(){
Data.FirstRun = True;
};

void FahrtRichtung::Run(){

		// The pre-state-machine List
	Data.OldOperationINT=Data.OperationINT;
		// Set the initial state
	if (Data.FirstRun){	// Sets the initial state
		Data.FirstRun = false;
		Data.StatusEnum = st_Efz_001_000_FahrtRichtung;
		Data.OperationEnum = op_none_FahrtRichtung;
	} else {	// If FirstRun=True then output of initial operation.
			// The state machine
		Data.OperationEnum = op_none_FahrtRichtung;
		switch (Data.StatusEnum) {
			case st_Efz_001_000_FahrtRichtung :	// Zustand 001 als Efz Operation 000
				
				if (	   !Data.SignB
					&& !Data.SignA
				){
					Data.StatusEnum = st_Efz_003_002_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
				if (	    Data.SignB
					&& !Data.SignA
				){
					Data.StatusEnum = st_Efz_002_001_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
			break;
			case st_Efz_002_001_FahrtRichtung :	// Zustand 002 als Efz Operation 001
				
				if (	    Data.SignB
					&&  Data.SignA
				){
					Data.StatusEnum = st_Efz_004_003_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
				if (	   !Data.SignB
					&&  Data.SignA
				){
					Data.StatusEnum = st_Efz_001_000_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
			break;
			case st_Efz_003_002_FahrtRichtung :	// Zustand 003 als Efz Operation 002
				
				if (	   !Data.SignA
					&&  Data.SignB
				){
					Data.StatusEnum = st_Efz_004_003_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
				if (	    Data.SignA
					&&  Data.SignB
				){
					Data.StatusEnum = st_Efz_001_000_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
			break;
			case st_Efz_004_003_FahrtRichtung :	// Zustand 004 als Efz Operation 003
				
				if (	   !Data.SignA
					&& !Data.SignB
				){
					Data.StatusEnum = st_Efz_002_001_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
				if (	    Data.SignA
					&& !Data.SignB
				){
					Data.StatusEnum = st_Efz_003_002_FahrtRichtung;
					Data.OperationEnum = op_none_FahrtRichtung;
				}
			break;
		}	// End switch Data.StatusEnum
	}	// End First Run
		// The Output List
	Data.mul = (
		    (Data.StatusEnum == st_Efz_001_000_FahrtRichtung)
		||  (Data.StatusEnum == st_Efz_002_001_FahrtRichtung)
	);
	Data.edul = (
		    (Data.StatusEnum == st_Efz_003_002_FahrtRichtung)
		||  (Data.StatusEnum == st_Efz_004_003_FahrtRichtung)
	);
		// The post-state-machine List
	if (Data.StatusEnum==st_Efz_001_000_FahrtRichtung){
		Data.OperationINT=Const_st_Efz_001_000;
	}
	if (Data.StatusEnum==st_Efz_002_001_FahrtRichtung){
		Data.OperationINT=Const_st_Efz_002_001;
	}
	if (Data.StatusEnum==st_Efz_003_002_FahrtRichtung){
		Data.OperationINT=Const_st_Efz_003_002;
	}
	if (Data.StatusEnum==st_Efz_004_003_FahrtRichtung){
		Data.OperationINT=Const_st_Efz_004_003;
	}
	

}


