
#ifndef FahrtRichtung_H
#define FahrtRichtung_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum FahrtRichtungStatusEnum {
st_Efz_001_000_FahrtRichtung, // Zustand 001 als Efz Operation 000
st_Efz_002_001_FahrtRichtung, // Zustand 002 als Efz Operation 001
st_Efz_003_002_FahrtRichtung, // Zustand 003 als Efz Operation 002
st_Efz_004_003_FahrtRichtung // Zustand 004 als Efz Operation 003
};

enum FahrtRichtungOperationEnum {
op_none_FahrtRichtung // Keine Operation
};


struct FahrtRichtungData {
// Input
BOOL SignA:1; // Signal A
BOOL SignB:1; // Signal B
// Output
BOOL mul:1; // Richtung im Uhrzeigersinn
BOOL edul:1; // Richtung gegen den Uhrzeigerlauf
// Local
BOOL FirstRun:1; // Sets the initial state
enum FahrtRichtungStatusEnum StatusEnum; // 
enum FahrtRichtungOperationEnum OperationEnum; // 
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
// Local Function Blocks
};

class FahrtRichtung{
public:
FahrtRichtung();
~FahrtRichtung();
void Init();
void Run();
struct FahrtRichtungData Data;
};
extern IOPLC ioplc;
#endif

