


#include "HubMot.h"

// Constants
const INT Const_op_1_000 = 0; // Operation 000 in Mfz 1
const INT Const_op_1_001 = 1; // Operation 001 in Mfz 1
const INT Const_op_1_002 = 2; // Operation 002 in Mfz 1
const INT Const_op_1_003 = 3; // Operation 003 in Mfz 1
const INT Const_op_1_004 = 4; // Operation 004 in Mfz 1

HubMot::HubMot(){
Data.KabMotNachOben = false;
Data.KabMotNachUnten = false;
Data.Et1langs = false;
Data.Et2langs = false;
Data.Et3langs = false;
Data.Autom = false;
Data.SenkHand = false;
Data.HebHand = false;
Data.KabNichtZuTief = false;
Data.KabNichtZuHoch = false;
Data.KabiNach_2_auf = false;
Data.KabiNach_3_auf = false;
Data.KabiNach_2_abw = false;
Data.KabiNach_1_abw = false;
Data.KabMotAUFW = false;
Data.KabMotLangsAUFW = false;
Data.KabMotABW = false;
Data.KabMotLangsABW = false;
Data.FirstRun = true;
Data.StatusEnum = (HubMotStatusEnum)0;
Data.OperationEnum = (HubMotOperationEnum)0;
Data.OldOperationINT = 0;
Data.OperationINT = 0;
Data.AVOR = false;
Init();
};

HubMot::~HubMot(){
};

void HubMot::Init(){
Data.FirstRun = True;
};

void HubMot::Run(){

		// The pre-state-machine List
	Data.OldOperationINT=Data.OperationINT;
		// Set the initial operation
	if (Data.FirstRun){	// Sets the initial state
		Data.FirstRun = false;
		Data.StatusEnum = st_Mfz_001_HubMot;
		Data.OperationEnum = op_1_000_HubMot;
	} else {	// If FirstRun=True then output of initial operation.
		if (	   !Data.Autom
			&& !Data.HebHand
			&& !Data.SenkHand
			|| (	    Data.Autom
				&&  Data.KabNichtZuTief
				&&  Data.KabNichtZuHoch
				&& !Data.KabMotNachOben	// KOP von KabMot_TuerStgn
				&& !Data.KabMotNachUnten
			)
		){
			Data.OperationEnum = op_1_000_HubMot;
		}
		if (	    Data.KabMotNachUnten
			&& !Data.KabMotNachOben	// KOP von KabMot_TuerStgn
			&&  Data.KabNichtZuHoch
			&&  Data.KabNichtZuTief
			&&  Data.Autom
			&& (	    Data.Et1langs
				&& !Data.KabiNach_1_abw
				|| (	   !Data.Et1langs
					&& (	   !Data.KabiNach_2_abw
						|| !Data.Et2langs
					)
				)
			)
			|| (	   !Data.Autom
				&& !Data.HebHand
				&&  Data.SenkHand
			)
		){
			Data.OperationEnum = op_1_004_HubMot;
		}
		if (	    Data.KabMotNachOben	// KOP von KabMot_TuerStgn
			&&  Data.KabNichtZuHoch
			&&  Data.KabNichtZuTief
			&&  Data.Autom
			&& (	    Data.Et2langs
				&& !Data.KabiNach_2_auf
				|| (	   !Data.Et2langs
					&& (	   !Data.Et3langs
						|| !Data.KabiNach_3_auf
					)
				)
			)
			|| (	   !Data.Autom
				&&  Data.HebHand
			)
		){
			Data.OperationEnum = op_1_002_HubMot;
		}
		if (	    Data.KabNichtZuTief
			&&  Data.Autom
			&& (	   !Data.KabNichtZuHoch
				|| (	    Data.KabMotNachUnten
					&& !Data.KabMotNachOben	// KOP von KabMot_TuerStgn
					&& (	   !Data.Et1langs
						&&  Data.Et2langs
						&&  Data.KabiNach_2_abw
						|| (	    Data.Et1langs
							&&  Data.KabiNach_1_abw
						)
					)
				)
			)
		){
			Data.OperationEnum = op_1_003_HubMot;
		}
		if (	    Data.Autom
			&& (	   !Data.KabNichtZuTief
				|| (	    Data.KabMotNachOben	// KOP von KabMot_TuerStgn
					&&  Data.KabNichtZuHoch
					&& (	   !Data.Et2langs
						&&  Data.Et3langs
						&&  Data.KabiNach_3_auf
						|| (	    Data.Et2langs
							&&  Data.KabiNach_2_auf
						)
					)
				)
			)
		){
			Data.OperationEnum = op_1_001_HubMot;
		}
	}	// End First Run
		// The Output List
	Data.KabMotLangsAUFW = (
		    (Data.OperationEnum == op_1_001_HubMot)
	);
	Data.KabMotAUFW = (
		    (Data.OperationEnum == op_1_002_HubMot)
	);
	Data.KabMotLangsABW = (
		    (Data.OperationEnum == op_1_003_HubMot)
	);
	Data.KabMotABW = (
		    (Data.OperationEnum == op_1_004_HubMot)
	);
		// The post-state-machine List
	if (Data.OperationEnum==op_1_000_HubMot){
		Data.OperationINT=Const_op_1_000;
	}
	if (Data.OperationEnum==op_1_001_HubMot){
		Data.OperationINT=Const_op_1_001;
	}
	if (Data.OperationEnum==op_1_002_HubMot){
		Data.OperationINT=Const_op_1_002;
	}
	if (Data.OperationEnum==op_1_003_HubMot){
		Data.OperationINT=Const_op_1_003;
	}
	if (Data.OperationEnum==op_1_004_HubMot){
		Data.OperationINT=Const_op_1_004;
	}
	

}


