


#ifndef HubMot_H
#define HubMot_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum HubMotStatusEnum {
st_Mfz_001_HubMot // Zustand 001 als Mfz
};

enum HubMotOperationEnum {
op_none_HubMot, // Keine Operation
op_1_000_HubMot, // Operation 000 in Mfz 1
op_1_001_HubMot, // Operation 001 in Mfz 1
op_1_002_HubMot, // Operation 002 in Mfz 1
op_1_003_HubMot, // Operation 003 in Mfz 1
op_1_004_HubMot // Operation 004 in Mfz 1
};


struct HubMotData {
// Input
BOOL KabMotNachOben:1; // Kabine nach oben
BOOL KabMotNachUnten:1; // Kabine nach unten
BOOL Et1langs:1; // Etage 1 langsam
BOOL Et2langs:1; // Etage 2 langsam
BOOL Et3langs:1; // Etage 3 langsam
BOOL Autom:1; // Automatik-\n betrieb
BOOL SenkHand:1; // Senken:\n Handbetrieb
BOOL HebHand:1; // Heben:\n Handbetrieb
BOOL KabNichtZuTief:1; // Kabine\n nicht zu tief
BOOL KabNichtZuHoch:1; // Kabine\n nicht zu hoch
BOOL KabiNach_2_auf:1; // Kabine nach\n 2 aufwrts
BOOL KabiNach_3_auf:1; // Kabine nach\n 3 aufwrts
BOOL KabiNach_2_abw:1; // Kabine nach\n 2 abwrts
BOOL KabiNach_1_abw:1; // Kabine nach\n 1 abwrts
// Output
BOOL KabMotAUFW:1; // Kabinenmotor schnell aufwrts
BOOL KabMotLangsAUFW:1; // Kabinenmotor langsam aufwrts
BOOL KabMotABW:1; // Kabinenmotor schnell abwrts
BOOL KabMotLangsABW:1; // Kabinenmotor langsam abwrts
// Local
BOOL FirstRun:1; // Sets the initial state
enum HubMotStatusEnum StatusEnum; // 
enum HubMotOperationEnum OperationEnum; // 
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
BOOL AVOR:1; // Avor Marke
// Local Function Blocks
};

class HubMot{
public:
HubMot();
~HubMot();
void Init();
void Run();
struct HubMotData Data;
};
extern IOPLC ioplc;
#endif

