
#include "Tuer_Position.h"

// Constants
const INT Const_op_1_000 = 0; // Operation 000 in Mfz 1
const INT Const_op_1_001 = 1; // Operation 001 in Mfz 1
const INT Const_op_1_002 = 2; // Operation 002 in Mfz 1

Tuer_Position::Tuer_Position(){
Data.Tuer_1_geschl = false;
Data.Tuer_2_geschl = false;
Data.Tuer_3_geschl = false;
Data.Tuer_1_geoeffn = false;
Data.Tuer_2_geoeffn = false;
Data.Tuer_3_geoeffn = false;
Data.Tueren_Geschl = false;
Data.eineTuer_offen = false;
Data.FirstRun = true;
Data.StatusEnum = (Tuer_PositionStatusEnum)0;
Data.OperationEnum = (Tuer_PositionOperationEnum)0;
Data.OldOperationINT = 0;
Data.OperationINT = 0;
Data.AVOR = false;
Init();
};

Tuer_Position::~Tuer_Position(){
};

void Tuer_Position::Init(){
Data.FirstRun = True;
};

void Tuer_Position::Run(){

		// The pre-state-machine List
	Data.OldOperationINT=Data.OperationINT;
		// Set the initial operation
	if (Data.FirstRun){	// Sets the initial state
		Data.FirstRun = false;
		Data.StatusEnum = st_Mfz_001_Tuer_Position;
		Data.OperationEnum = op_1_000_Tuer_Position;
	} else {	// If FirstRun=True then output of initial operation.
		if (	   !Data.Tuer_3_geschl
			&& (	    Data.Tuer_1_geschl
				&& !Data.Tuer_3_geoeffn
				|| !Data.Tuer_2_geschl
				|| !Data.Tuer_1_geschl
			)
			|| (	   !Data.Tuer_2_geschl
				&& (	   !Data.Tuer_2_geoeffn
					|| !Data.Tuer_1_geschl
				)
			)
			|| (	   !Data.Tuer_1_geschl
				&& !Data.Tuer_1_geoeffn
			)
		){
			Data.OperationEnum = op_1_000_Tuer_Position;
		}
		if (	    Data.Tuer_1_geschl
			&&  Data.Tuer_2_geschl
			&&  Data.Tuer_3_geschl
		){
			Data.OperationEnum = op_1_001_Tuer_Position;
		}
		if (	    Data.Tuer_1_geschl
			&& (	    Data.Tuer_2_geschl
				&& !Data.Tuer_3_geschl
				&&  Data.Tuer_3_geoeffn
				|| (	   !Data.Tuer_2_geschl
					&&  Data.Tuer_3_geschl
					&&  Data.Tuer_2_geoeffn
				)
			)
			|| (	   !Data.Tuer_1_geschl
				&&  Data.Tuer_2_geschl
				&&  Data.Tuer_3_geschl
				&&  Data.Tuer_1_geoeffn
			)
		){
			Data.OperationEnum = op_1_002_Tuer_Position;
		}
	}	// End First Run
		// The Output List
	Data.Tueren_Geschl = (
		    (Data.OperationEnum == op_1_001_Tuer_Position)
	);
	Data.eineTuer_offen = (
		    (Data.OperationEnum == op_1_002_Tuer_Position)
	);
		// The post-state-machine List
	if (Data.OperationEnum==op_1_000_Tuer_Position){
		Data.OperationINT=Const_op_1_000;
	}
	if (Data.OperationEnum==op_1_001_Tuer_Position){
		Data.OperationINT=Const_op_1_001;
	}
	if (Data.OperationEnum==op_1_002_Tuer_Position){
		Data.OperationINT=Const_op_1_002;
	}
	

}


