
#ifndef Tuerstrg_H
#define Tuerstrg_H

#include "iec1131/iec1131_std_types.h"
#include "iec1131/iec1131_std_fb.h"
#include "ioplc/ioplc.h"

enum TuerstrgStatusEnum {
st_Mfz_001_Tuerstrg // Zustand 001 als Mfz
};

enum TuerstrgOperationEnum {
op_none_Tuerstrg, // Keine Operation
op_1_000_Tuerstrg, // Operation 000 in Mfz 1
op_1_001_Tuerstrg, // Operation 001 in Mfz 1
op_1_002_Tuerstrg, // Operation 002 in Mfz 1
op_1_003_Tuerstrg // Operation 003 in Mfz 1
};


struct TuerstrgData {
// Input
BOOL ZielErr:1; // Zieletage erreicht
BOOL SollTuerOeff:1; // Soll Tr\n geffnet werden
BOOL SollTuerSchl:1; // Soll Tr geschlossen werden
BOOL TuerGeoeffn:1; // Tr geffnet
BOOL TuerGeschl:1; // Tr geschlossen
BOOL Automat:1; // Automatikbetrieb
BOOL TuerOeffVHd:1; // Handbetrieb:\n Tr ffnen
BOOL TuerSchlVHd:1; // Handbetrieb:\n Tr schlieen
// Output
BOOL TuerOeff_EIN:1; // Tr-Motor: Tr ffnen
BOOL TuerSchli_EIN:1; // Tr-Motor: Tr schlieen
// Local
BOOL FirstRun:1; // Sets the initial state
enum TuerstrgStatusEnum StatusEnum; // 
enum TuerstrgOperationEnum OperationEnum; // 
INT OldOperationINT; // Alte Operationscodierung
INT OperationINT; // Operationscodierung
BOOL AVOR:1; // Avor Marke
// Local Function Blocks
};

class Tuerstrg{
public:
Tuerstrg();
~Tuerstrg();
void Init();
void Run();
struct TuerstrgData Data;
};
extern IOPLC ioplc;
#endif

