FUNCTION  "Start_Input" : "BOOL"
VAR CONSTANT
true : BOOL := 1; (*Logisch 1*)
END_VAR
VAR_OUTPUT
InitState_1 : BOOL; (*Starzustand TP 1*)
END_VAR
	InitState_1  :=  1;
	Start_Input  :=  1;

END_FUNCTION


PROGRAM  InitProg_Input  (*Anlaufprogramm Input_Test_Station*)

END_PROGRAM


FUNCTION_BLOCK  ConveyorDrive
{ DATE & TIME :  19.02.2007 11:03:10 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_op_1_001 : INT := 1; (*Operation 001 in Mfz 1*)
Const_op_1_002 : INT := 2; (*Operation 002 in Mfz 1*)
Const_st_Efz_002_000 : INT := 0; (*Zustand 002 als Efz Operation 000*)
StartTimerValue : TIME := 5000; (*Timer Value Initiation*)
END_VAR
VAR_INPUT
HousingAtEnd : BOOL; (*Primary Variable Falling Edge*)
HousingOnRoll_Off : BOOL; (*Gehuse auf Abtransport-Position*)
Housing_Rejected : BOOL; (*Gehuse ausgeworfen*)
Start : BOOL; (*Start-Taster bettigt*)
Stop : BOOL; (*Stop-Taster bettigt*)
END_VAR
VAR_OUTPUT
ConvCorrectRun : BOOL; (*Band luft*)
MotorON : BOOL; (*Bandmotor ein*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
END_VAR
VAR
ConvCtrlTime_over : BOOL; (*Band luft nach Anlaufzeit*)
HousingAfterBelt : BOOL; (*Prfling verlsst Bandende*)
CtrlTimer : BOOL; (*Anlauftimer ein*)
st_Mfz_001 : BOOL; (*Zustand 001 als Mfz*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
st_Efz_002_000 : BOOL; (*Zustand 002 als Efz Operation 000*)
StartTimer : TON; (*StartTimer Initiation*)
HousingAtEnd_F : F_TRIG; (*trigger FB of  "HousingAtEnd"*)
OldOperationINT : INT := 0; (*Alte Operationscodierung*)
OperationINT : INT := 0; (*Operationscodierung*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	ConvCtrlTime_over  :=  StartTimer.Q;
	HousingAtEnd_F(CLK := HousingAtEnd);
	HousingAfterBelt := HousingAtEnd_F.Q;
	OldOperationINT  :=  OperationINT;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 002;	(* Initial situation *)
			st_Efz_002_000 := TRUE;
			st_Mfz_001 := FALSE;
			op_1_001 := FALSE;
			op_1_002 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF Stop OR(NOT Stop AND HousingAfterBelt AND NOT Housing_Rejected
		 AND NOT HousingOnRoll_Off)
		THEN STATE := 002;st_Efz_002_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_000
	 THEN st_Mfz_001 := FALSE;
	op_1_001 := FALSE;
	op_1_002 := FALSE;
	END_IF
	002: IF Start AND NOT Stop
		THEN op_1_001 := TRUE;
	END_IF
	IF op_1_001
	THEN STATE := 001;st_Mfz_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Mfz_001
	 THEN st_Efz_002_000 := FALSE;
	END_IF
	END_CASE
		(* Output precalculation *)
	IF NOT op_1_001 THEN  
	CASE STATE OF
	001: op_1_001 := NOT ConvCtrlTime_over AND NOT Stop AND(NOT HousingAfterBelt
		 OR HousingOnRoll_Off OR Housing_Rejected);
		op_1_002 := ConvCtrlTime_over AND NOT Stop AND(NOT HousingAfterBelt OR HousingOnRoll_Off
		 OR Housing_Rejected);
	END_CASE;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	ConvCorrectRun := op_1_002;
	MotorON := op_1_001 OR op_1_002;
	CtrlTimer := HousingAfterBelt;
		(* The post-state-machine list *)
	IF op_1_001
	THEN OperationINT  :=  1;
	END_IF
	IF op_1_002
	THEN OperationINT  :=  2;
	END_IF
	IF st_Efz_002_000
	THEN OperationINT  :=  0;
	END_IF
	StartTimer(IN:=CtrlTimer,PT:=T#05S000MS);

END_FUNCTION_BLOCK


FUNCTION_BLOCK  ComponentFeeder
{ DATE & TIME :  19.02.2007 11:03:10 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_st_Efz_001_000 : INT := 0; (*Zustand 001 als Efz Operation 000*)
Const_st_Efz_002_001 : INT := 1; (*Zustand 002 als Efz Operation 001*)
END_VAR
VAR_INPUT
ConvRunning : BOOL; (*Band luft*)
HousingOffConv : BOOL; (*Gehuse hat Band verlassen*)
HousingOnBoard : BOOL; (*Gehuse steht bereit*)
Housing_QualityDone : BOOL; (*Gehuse von Qualitts- station erfasst*)
END_VAR
VAR_OUTPUT
Feeder_On : BOOL; (*Gehuse auf Band schieben*)
HousingOnBelt : BOOL; (*Gehuse auf Band*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
END_VAR
VAR
st_Efz_001_000 : BOOL; (*Zustand 001 als Efz Operation 000*)
st_Efz_002_001 : BOOL; (*Zustand 002 als Efz Operation 001*)
OldOperationINT : INT := 0; (*Alte Operationscodierung*)
OperationINT : INT := 0; (*Operationscodierung*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Efz_001_000 := TRUE;
			st_Efz_002_001 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF HousingOnBoard AND ConvRunning
		THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_001
	 THEN st_Efz_001_000 := FALSE;
	END_IF
	002: IF HousingOffConv AND Housing_QualityDone AND(NOT ConvRunning OR NOT HousingOnBoard
		)
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000
	 THEN st_Efz_002_001 := FALSE;
	END_IF
	END_CASE
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	Feeder_On := st_Efz_002_001;
	HousingOnBelt := st_Efz_002_001;
		(* The post-state-machine list *)
	IF st_Efz_001_000
	THEN OperationINT  :=  0;
	END_IF
	IF st_Efz_002_001
	THEN OperationINT  :=  1;
	END_IF

END_FUNCTION_BLOCK


PROGRAM  Drive_And_Feeder  (*Programm Antrieb und Zufhrung*)
VAR
ConveyorDrive_3 : ConveyorDrive; (*Frderbandantrieb*)
ComponentFeeder_1 : ComponentFeeder; (*Gehuse auf Band schieben*)
END_VAR

END_PROGRAM


RESOURCE Input_Test_Station ON PROCESSOR zero  (*Eingang der Prflinge in die Test-Station*)
TASK  RUN(SINGLE := RUN_VARIABLE, PRIORITY:= 1);
TASK  Task_1.1(INTERVAL := 0, PRIORITY:= 31);
 Init_Inst  WITH RUN: InitProg_Input;
 DriveAndFeed  WITH Task_1.1: Drive_And_Feeder;
END_RESOURCE


