FUNCTION  "Start_Output" : "BOOL"
VAR CONSTANT
true : BOOL := 1; (*Logisch 1*)
END_VAR
VAR_OUTPUT
InitState_2 : BOOL; (*Initializustand TP 3*)
END_VAR
	InitState_2  :=  1;
	Start_Output  :=  1;

END_FUNCTION


PROGRAM  InitProgr_Output  (*Anlaufprogramm der Output_Test_Station*)

END_PROGRAM


FUNCTION_BLOCK  Quality_Acceptance_Station
{ DATE & TIME :  19.02.2007 11:03:46 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_op_1_002 : INT := 2; (*Operation 002 in Mfz 1*)
Const_op_1_003 : INT := 3; (*Operation 003 in Mfz 1*)
Const_st_Efz_002_000 : INT := 0; (*Zustand 002 als Efz Operation 000*)
Const_st_Efz_003_001 : INT := 1; (*Zustand 003 als Efz Operation 001*)
END_VAR
VAR_INPUT
ConvRunning : BOOL; (*Band luft*)
Housing_OnBelt : BOOL; (*Gehuse auf Frderband*)
Housing_onEnd_Belt : BOOL; (*Gehuse am Bandende*)
Measuring_OK : BOOL; (*Messdaten in Ordnung*)
END_VAR
VAR_OUTPUT
Housing_OK : BOOL; (*Gehuse in Ordnung*)
SendData : BOOL; (*Datenausgabe*)
Start_Measuring : BOOL; (*Qualittsmessgerte EIN*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
END_VAR
VAR
st_Mfz_001 : BOOL; (*Zustand 001 als Mfz*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
op_1_003 : BOOL; (*Operation 003 in Mfz 1*)
st_Efz_002_000 : BOOL; (*Zustand 002 als Efz Operation 000*)
st_Efz_003_001 : BOOL; (*Zustand 003 als Efz Operation 001*)
OldOperationINT : INT := 0; (*Alte Operationscodierung*)
OperationINT : INT := 0; (*Operationscodierung*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 002;	(* Initial situation *)
			st_Efz_002_000 := TRUE;
			st_Mfz_001 := FALSE;
			op_1_002 := FALSE;
			op_1_003 := FALSE;
			st_Efz_003_001 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF NOT ConvRunning
		THEN STATE := 002;st_Efz_002_000 := TRUE;
	END_IF
	IF ConvRunning AND NOT Housing_onEnd_Belt AND ConvRunning
	THEN STATE := 003;st_Efz_003_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_000 OR st_Efz_003_001
	 THEN st_Mfz_001 := FALSE;
	op_1_002 := FALSE;
	op_1_003 := FALSE;
	END_IF
	002: IF Housing_OnBelt AND ConvRunning
		THEN STATE := 003;st_Efz_003_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_003_001
	 THEN st_Efz_002_000 := FALSE;
	END_IF
	003: IF NOT Housing_onEnd_Belt AND NOT ConvRunning
		THEN STATE := 002;st_Efz_002_000 := TRUE;
	END_IF
	IF Housing_onEnd_Belt AND Measuring_OK
	THEN op_1_002 := TRUE;
	END_IF
	IF Housing_onEnd_Belt AND NOT Measuring_OK
	THEN op_1_003 := TRUE;
	END_IF
	IF op_1_002 OR op_1_003
	THEN STATE := 001;st_Mfz_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_000 OR st_Mfz_001
	 THEN st_Efz_003_001 := FALSE;
	END_IF
	END_CASE
		(* Output precalculation *)
	IF NOT op_1_002 THEN  
	CASE STATE OF
	001: op_1_002 := ConvRunning AND Housing_onEnd_Belt AND Measuring_OK;
		op_1_003 := ConvRunning AND Housing_onEnd_Belt AND NOT Measuring_OK;
	END_CASE;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	Housing_OK := op_1_002;
	Start_Measuring := st_Efz_003_001;
	SendData := op_1_002 OR op_1_003;
		(* The post-state-machine list *)
	IF op_1_002
	THEN OperationINT  :=  2;
	END_IF
	IF op_1_003
	THEN OperationINT  :=  3;
	END_IF
	IF st_Efz_002_000
	THEN OperationINT  :=  0;
	END_IF
	IF st_Efz_003_001
	THEN OperationINT  :=  1;
	END_IF

END_FUNCTION_BLOCK


FUNCTION_BLOCK  RollOff_Reject
{ DATE & TIME :  19.02.2007 11:03:46 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_op_1_000 : INT := 0; (*Operation 000 in Mfz 1*)
Const_op_1_001 : INT := 1; (*Operation 001 in Mfz 1*)
Const_st_Efz_002_002 : INT := 2; (*Zustand 002 als Efz Operation 002*)
END_VAR
VAR_INPUT
ConvRunning : BOOL; (*Band luft*)
HousingOnRoll_Off : BOOL; (*Gehuse auf Abtransport-Position*)
QualOK : BOOL; (*Qualitt in Ordnung*)
END_VAR
VAR_OUTPUT
Component_Rejected : BOOL; (*Gehuse ausgeworfen*)
Housing_RollOff : BOOL; (*Abtransport*)
Reject : BOOL; (*Auswurfklappe nach oben*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
END_VAR
VAR
st_Mfz_001 : BOOL; (*Zustand 001 als Mfz*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
st_Efz_002_002 : BOOL; (*Zustand 002 als Efz Operation 002*)
OldOperationINT : INT := 0; (*Alte Operationscodierung*)
OperationINT : INT := 0; (*Operationscodierung*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Mfz_001 := TRUE;
			op_1_000 := TRUE;
			op_1_001 := FALSE;
			st_Efz_002_002 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF ConvRunning AND QualOK AND HousingOnRoll_Off
		THEN STATE := 002;st_Efz_002_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_002
	 THEN st_Mfz_001 := FALSE;
	op_1_000 := FALSE;
	op_1_001 := FALSE;
	END_IF
	002: IF 
		THEN STATE := 001;st_Mfz_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Mfz_001
	 THEN st_Efz_002_002 := FALSE;
	END_IF
	END_CASE
		(* Output precalculation *)
	IF  THEN  
	CASE STATE OF
	001: op_1_000 := NOT ConvRunning OR(ConvRunning AND QualOK AND NOT HousingOnRoll_Off
		);
		op_1_001 := ConvRunning AND NOT QualOK;
	END_CASE;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	Reject := op_1_001;
	Component_Rejected := op_1_001;
	Housing_RollOff := st_Efz_002_002;
		(* The post-state-machine list *)
	IF op_1_000
	THEN OperationINT  :=  0;
	END_IF
	IF op_1_001
	THEN OperationINT  :=  1;
	END_IF
	IF st_Efz_002_002
	THEN OperationINT  :=  2;
	END_IF

END_FUNCTION_BLOCK


PROGRAM  Quality_And_Component_Off  (*Qualitts-Test und Abtransport*)
VAR
Quality_Acceptance_2 : Quality_Acceptance_Station; (*Qualitts-Test*)
MoveOff_Component_4 : RollOff_Reject; (*Abtransport*)
END_VAR

END_PROGRAM


RESOURCE Output_Test_Station ON PROCESSOR zero  (*Ausgang der Prflinge aus der Test-Station*)
TASK  RUN(SINGLE := RUN_VARIABLE, PRIORITY:= 1);
TASK  Task_1(INTERVAL := 0, PRIORITY:= 31);
 InitInst_Output  WITH RUN: InitProgr_Output;
 Quality_Housing_Off  WITH Task_1: Quality_And_Component_Off;
END_RESOURCE


