FUNCTION_BLOCK  DERIVATIVE
{ DATE & TIME :  29.05.2006 10:27:05 }
{ VERSION : 1.4 }
VAR_INPUT
RUN : BOOL; (*RUN*)
XIN : REAL; (*Eingabe, wird differenziiert*)
CYCLE : TIME; (*Abtastperiode*)
END_VAR
VAR_OUTPUT
XOUT : REAL; (*Differenziierter Ausgang*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
END_VAR
VAR
ausg : BOOL; (*Ausgabe der diff. Eingabe*)
init : BOOL; (*Anfangswerte*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
X1 : REAL; (*Zwischenwert1*)
X2 : REAL; (*Zwischenwert2*)
X3 : REAL; (*Zwischenwert3*)
END_VAR
		(* Set the initial operation *)
	IF FirstRun THEN ;
			op_1_000 := TRUE;
			op_1_001 := FALSE;
	END_IF
		(* Output precalculation *)
	IF NOT FirstRun THEN 
	op_1_000 := NOT RUN;
	op_1_001 := RUN;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	init := op_1_000;
	ausg := op_1_001;
		(* The post-state-machine list *)
	IF ausg
	THEN XOUT  :=  (3.0*(XIN-X3)+X1-X2)/(10.0*TIME_TO_REAL(CYCLE));
	X3  :=  X2;
	X2  :=  X1;
	X1  :=  XIN;
	END_IF
	IF init
	THEN XOUT  :=  0.0;
	X1  :=  XIN;
	X2  :=  XIN;
	X3  :=  XIN;
	END_IF

END_FUNCTION_BLOCK


FUNCTION_BLOCK  INTEGRAL
{ DATE & TIME :  29.05.2006 10:27:05 }
{ VERSION : 1.4 }
VAR_INPUT
R1 : BOOL; (*Vorrangiges Rcksetzen R1*)
RUN : BOOL; (*RUN*)
X0 : REAL; (*Initialwert fr Ausgabe*)
XIN : REAL; (*Eingabe-Variable*)
CYCLE : TIME; (*Abtastperiode*)
END_VAR
VAR_OUTPUT
Q : BOOL; (*Q = Not R1*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
XOUT : REAL; (*Integrierte Ausgabe*)
END_VAR
VAR
OUT1 : BOOL; (*Ausgabe-Initialisierung*)
OUT2 : BOOL; (*Integralwertberechnung*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
END_VAR
		(* Set the initial operation *)
	IF FirstRun THEN ;
			op_1_002 := TRUE;
			op_1_000 := FALSE;
			op_1_001 := FALSE;
	END_IF
		(* Output precalculation *)
	IF NOT FirstRun THEN 
	op_1_000 := NOT R1 AND RUN;
	op_1_001 := NOT R1 AND NOT RUN;
	op_1_002 := R1;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	OUT2 := op_1_000;
	Q := op_1_000 OR op_1_001;
	OUT1 := op_1_002;
		(* The post-state-machine list *)
	IF OUT1
	THEN XOUT  :=  X0;
	END_IF
	IF OUT2
	THEN XOUT  :=  XOUT+XIN*TIME_TO_REAL(CYCLE);
	END_IF

END_FUNCTION_BLOCK


FUNCTION_BLOCK  PID_CALC
{ DATE & TIME :  29.05.2006 10:27:05 }
{ VERSION : 1.4 }
VAR_INPUT
AUTO : BOOL; (*Hand /  Automatik *)
PV : REAL; (*Istwert (Preset Value)*)
SP : REAL; (*Sollwert (Set Point)*)
X0 : REAL; (*Nachfhrung*)
KP : REAL; (*Proportionalbeiwert*)
TR : TIME; (*Nachstellzeit*)
TD : TIME; (*Vorhaltezeit*)
CYCLEpid : TIME; (*Abtastperiode fr PID-Regler*)
END_VAR
VAR_OUTPUT
XOUTpid : REAL; (*PID_Ausgang*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := TRUE; (*Variable sets Start State*)
FirstRunDt : BOOL; (*Variable sets Start State*)
FirstRunIt : BOOL; (*Variable sets Start State*)
END_VAR
VAR
Calculate : BOOL; (*PID-Wert berechnen*)
Not_AUTO : BOOL; (*Neg. AUTO*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
ERROR : REAL; (*Ist-Soll-Differenz*)
X0Man : REAL; (*Manuelle Fhrung*)
ITERM : INTEGRAL; (*Integration*)
DTERM : DERIVATIVE; (*Differentiation*)
END_VAR
		(* Set the initial operation *)
	IF FirstRun THEN ;
			op_1_000 := TRUE;
			op_1_001 := FALSE;
	END_IF
		(* Output precalculation *)
	IF NOT FirstRun THEN 
	op_1_000 := NOT AUTO;
	op_1_001 := AUTO;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	Not_AUTO := op_1_000;
	Calculate := op_1_000 OR op_1_001;
		(* The post-state-machine list *)
	IF Calculate
	THEN ERROR  :=  PV-SP;
	X0Man  :=  TIME_TO_REAL(TR)*(X0-ERROR);
	ITERM(
	  CYCLE := CYCLEpid,
	  R1 := Not_AUTO,
	  RUN := AUTO,
	  X0 := X0Man,
	  XIN := ERROR,
	  FirstRun := FirstRunIt);
	DTERM(
	  CYCLE := CYCLEpid,
	  RUN := AUTO,
	  XIN := ERROR,
	  FirstRun := FirstRunDt);
	XOUTpid  :=  KP*(ERROR+ITERM.XOUT/TIME_TO_REAL(TR)+DTERM.XOUT*TIME_TO_REAL(TD));
	END_IF

END_FUNCTION_BLOCK

