FUNCTION  "StartZustand" : "BOOL"
VAR_OUTPUT
InitState_1 : BOOL; (*Startzustand_1*)
InitState_2 : BOOL; (*Startzustand_2*)
InitState_3 : BOOL; (*Startzustand_3*)
InitState_4 : BOOL; (*Startzustand_4*)
InitState_5 : BOOL; (*Startzustand_5*)
END_VAR
	InitState_1  :=  1;
	InitState_2  :=  1;
	InitState_3  :=  1;
	InitState_4  :=  1;
	InitState_5  :=  1;
	StartZustand  :=  1;

END_FUNCTION


PROGRAM  Anlauf  (*Anlauf bei z.B. Warmstart*)
VAR_EXTERNAL
InitVar_1 : BOOL; (*Init-Variable TP1*)
InitVar_2 : BOOL; (*Init-Variable TP2*)
InitVar_3 : BOOL; (*Init-Variable TP3*)
InitVar_4 : BOOL; (*Init-Variable TP4*)
InitVar_5 : BOOL; (*Init-Variable TP5*)
END_VAR

InitVar_5 := StartZustand(
InitState_1 => InitVar_1,
InitState_2 => InitVar_2,
InitState_3 => InitVar_3,
InitState_4 => InitVar_4);

END_PROGRAM


FUNCTION_BLOCK  HMI_Control
{ DATE & TIME :  27.04.2006 11:22:01 }
{ VERSION : 1.4 }
VAR_INPUT
BIN_LEVEL_EQU_SET_POINT : BOOL; (*Bin level equal set point*)
FILL_PB : BOOL; (*Fill Bin Push Button pressed*)
LAMP_TEST : BOOL; (*LAMP_TEST pressed*)
OFF_PB : BOOL; (*OFF_PB pressed*)
ON_PB : BOOL; (*ON_PB pressed*)
TRUCK_LOADED : BOOL; (*Truck loaded ready*)
BIN_LEVEL : BYTE := 0; (*Bin Level*)
END_VAR
VAR_OUTPUT
CONTROL : BOOL; (*Control On*)
CtrlLamp : BOOL; (*Control Lamp*)
Fill_Bin : BOOL; (*Fill Bin*)
END_VAR
VAR
FirstRun : BOOL := true; (*Erstlaufkennung*)
st_Efz_001_000 : BOOL; (*Zustand 001 als Efz Operation 000*)
st_Efz_002_001 : BOOL; (*Zustand 002 als Efz Operation 001*)
st_Efz_003_002 : BOOL; (*Zustand 003 als Efz Operation 002*)
st_Efz_004_003 : BOOL; (*Zustand 004 als Efz Operation 003*)
st_Efz_005_004 : BOOL; (*Zustand 005 als Efz Operation 004*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Efz_001_000 := TRUE;
			st_Efz_002_001 := FALSE;
			st_Efz_003_002 := FALSE;
			st_Efz_004_003 := FALSE;
			st_Efz_005_004 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF LAMP_TEST AND(NOT ON_PB OR OFF_PB)
		THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
	IF ON_PB AND NOT OFF_PB
	THEN STATE := 003;st_Efz_003_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_001 OR st_Efz_003_002
	 THEN st_Efz_001_000 := FALSE;
	END_IF
	002: IF NOT LAMP_TEST
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000
	 THEN st_Efz_002_001 := FALSE;
	END_IF
	003: IF NOT OFF_PB AND FILL_PB
		THEN STATE := 004;st_Efz_004_003 := TRUE;
	END_IF
	IF OFF_PB AND OFF_PB AND NOT LAMP_TEST
	THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
	IF OFF_PB AND OFF_PB AND LAMP_TEST
	THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_004_003 OR st_Efz_001_000 OR st_Efz_002_001
	 THEN st_Efz_003_002 := FALSE;
	END_IF
	004: IF NOT OFF_PB AND BIN_LEVEL_EQU_SET_POINT
		THEN STATE := 005;st_Efz_005_004 := TRUE;
	END_IF
	IF OFF_PB AND NOT LAMP_TEST
	THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
	IF OFF_PB AND LAMP_TEST
	THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_004 OR st_Efz_001_000 OR st_Efz_002_001
	 THEN st_Efz_004_003 := FALSE;
	END_IF
	005: IF NOT OFF_PB AND TRUCK_LOADED
		THEN STATE := 003;st_Efz_003_002 := TRUE;
	END_IF
	IF OFF_PB AND NOT LAMP_TEST
	THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
	IF OFF_PB AND LAMP_TEST
	THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_003_002 OR st_Efz_001_000 OR st_Efz_002_001
	 THEN st_Efz_005_004 := FALSE;
	END_IF
	END_CASE
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	Fill_Bin := st_Efz_004_003;
	CONTROL := st_Efz_003_002 OR st_Efz_004_003 OR st_Efz_005_004;
	CtrlLamp := st_Efz_002_001 OR st_Efz_003_002 OR st_Efz_004_003 OR st_Efz_005_004;

END_FUNCTION_BLOCK


FUNCTION_BLOCK  BIN_Volume
{ DATE & TIME :  27.04.2006 11:22:01 }
{ VERSION : 1.4 }
VAR_INPUT
Dump_Bin_Begin : BOOL; (*BIN Dumping begin*)
FILL_Begin : BOOL; (*Fill In Begin*)
SET_POINT : BYTE; (*Sollwert Behlterfllung*)
END_VAR
VAR_OUTPUT
BIN_LEVEL : BYTE; (*Arithmetic Operand*)
END_VAR
VAR_IN_OUT
BinLevel_Equ_SP : BOOL; (*Result of Comparison*)
END_VAR
VAR
BIN_Zero : BOOL; (*Bin Level equal to Zero*)
Beat1End : BOOL; (*Beat Time 1 Over*)
Beat2End : BOOL; (*Beat Time 2 Over*)
BinLevEquSP : BOOL; (*Bin Level equal Set Point*)
BT1 : BOOL; (*Beat Timer 1*)
BT2 : BOOL; (*Beat Timer 2*)
CountDown : BOOL; (*Counting down*)
CountUp : BOOL; (*Counting Up*)
ImpSP : BOOL; (*Bin Level comp. with Set Point and Bin Level Output*)
UDCounter : BOOL; (*Up Down Counter On*)
FirstRun : BOOL := true; (*Erstlaufkennung*)
st_Efz_001_000 : BOOL; (*Zustand 001 als Efz Operation 000*)
st_Efz_002_001 : BOOL; (*Zustand 002 als Efz Operation 001*)
st_Efz_003_002 : BOOL; (*Zustand 003 als Efz Operation 002*)
st_Efz_004_003 : BOOL; (*Zustand 004 als Efz Operation 003*)
st_Efz_005_004 : BOOL; (*Zustand 005 als Efz Operation 004*)
Value_Sint : SINT; (*Zwischenwert*)
Timer1 : TON; (*Timer Variable Initiation*)
Timer2 : TON; (*Timer Variable Initiation*)
Up_Down_Counter : CTUD; (*Counter Variable Initiation*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	BIN_Zero  :=  Up_Down_Counter.QD;
	Beat2End  :=  Timer2.Q;
	BinLevEquSP  :=  BinLevel_Equ_SP = 1;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Efz_001_000 := TRUE;
			st_Efz_002_001 := FALSE;
			st_Efz_003_002 := FALSE;
			st_Efz_004_003 := FALSE;
			st_Efz_005_004 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF NOT FILL_Begin AND Dump_Bin_Begin
		THEN STATE := 004;st_Efz_004_003 := TRUE;
	END_IF
	IF FILL_Begin
	THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_004_003 OR st_Efz_002_001
	 THEN st_Efz_001_000 := FALSE;
	END_IF
	002: IF Beat1End
		THEN STATE := 003;st_Efz_003_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_003_002
	 THEN st_Efz_002_001 := FALSE;
	END_IF
	003: IF Beat2End AND BinLevEquSP
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
	IF Beat2End AND NOT BinLevEquSP
	THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000 OR st_Efz_002_001
	 THEN st_Efz_003_002 := FALSE;
	END_IF
	004: IF Beat1End
		THEN STATE := 005;st_Efz_005_004 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_004
	 THEN st_Efz_004_003 := FALSE;
	END_IF
	005: IF Beat2End AND NOT BIN_Zero
		THEN STATE := 004;st_Efz_004_003 := TRUE;
	END_IF
	IF Beat2End AND BIN_Zero
	THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_004_003 OR st_Efz_001_000
	 THEN st_Efz_005_004 := FALSE;
	END_IF
	END_CASE
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	UDCounter := st_Efz_001_000;
	CountUp := st_Efz_003_002;
	BT1 := st_Efz_002_001 OR st_Efz_004_003;
	ImpSP := st_Efz_001_000 OR st_Efz_002_001 OR st_Efz_004_003;
	BT2 := st_Efz_003_002 OR st_Efz_005_004;
	CountDown := st_Efz_005_004;
		(* The post-state-machine list *)
	IF ImpSP
	THEN Value_Sint  :=  BYTE_BCD_TO_SINT(SET_POINT);
	IF Up_Down_Counter.CV = SINT_TO_INT(Value_Sint)
	THEN BinLevel_Equ_SP  :=  1;
	ELSE 
		BinLevel_Equ_SP  :=  0;
	END_IF
	Value_Sint  :=  INT_TO_SINT(Up_Down_Counter.CV);
	BIN_LEVEL  :=  SINT_TO_BCD_BYTE(Value_Sint);
	END_IF
	Timer1(IN:=BT1,PT:=T#500MS);
	Timer2(IN:=BT2,PT:=T#500MS);
	Up_Down_Counter(CD:=CountDown,CU:=CountUp,LD:=UDCounter,PV:=0);

END_FUNCTION_BLOCK


FUNCTION_BLOCK  CONVEYOR_MOTOR
{ DATE & TIME :  27.04.2006 11:22:01 }
{ VERSION : 1.4 }
VAR_INPUT
BIN_EMPTY : BOOL; (*Bin is empty*)
BLINK : BOOL; (*Blink*)
CONTROL : BOOL; (*Control On*)
JOG_PB : BOOL; (*Motor by JOG*)
LAMP_TEST : BOOL; (*Lamp Test*)
StartConv : BOOL; (*Start Conveyor*)
TRUCK_ON_RAMP : BOOL; (*Truck on Ramp*)
RUN_IN_Value : TIME; (*Timer Value Initiation*)
RUN_OUT_Value : TIME; (*Timer Value Initiation*)
END_VAR
VAR_OUTPUT
CONVEYOR_LAMP : BOOL; (*Conveyor Lamp On*)
CONVEYOR_MOTOR : BOOL; (*Conveyor Motor On*)
Conv_Stopped : BOOL; (*Conveyor Stopped*)
DUMP_BIN : BOOL; (*Dump Start*)
TRUCK_LAMP : BOOL; (*Lamp Truck On Ramp*)
END_VAR
VAR
EndRunOut : BOOL; (*End of Run Out Time*)
End_RUN_IN : BOOL; (*End of Run In Time*)
RunInTim : BOOL; (*Run In Timer*)
RunOutTim : BOOL; (*Run Out Timer*)
FirstRun : BOOL := true; (*Erstlaufkennung*)
st_Mfz_001 : BOOL; (*Zustand 001 als Mfz*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
op_1_010 : BOOL; (*Operation 010 in Mfz 1*)
st_Mfz_002 : BOOL; (*Zustand 002 als Mfz*)
op_2_002 : BOOL; (*Operation 002 in Mfz 2*)
op_2_006 : BOOL; (*Operation 006 in Mfz 2*)
st_Mfz_003 : BOOL; (*Zustand 003 als Mfz*)
op_3_003 : BOOL; (*Operation 003 in Mfz 3*)
op_3_007 : BOOL; (*Operation 007 in Mfz 3*)
st_Mfz_004 : BOOL; (*Zustand 004 als Mfz*)
op_4_004 : BOOL; (*Operation 004 in Mfz 4*)
op_4_008 : BOOL; (*Operation 008 in Mfz 4*)
st_Efz_005_000 : BOOL; (*Zustand 005 als Efz Operation 000*)
st_Efz_006_005 : BOOL; (*Zustand 006 als Efz Operation 005*)
st_Efz_007_009 : BOOL; (*Zustand 007 als Efz Operation 009*)
RUN_IN_Timer : TON; (*Timer Variable Initiation*)
RUN_OUT_Timer : TON; (*Timer Variable Initiation*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	EndRunOut  :=  RUN_OUT_Timer.Q;
	End_RUN_IN  :=  RUN_IN_Timer.Q;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 005;	(* Initial situation *)
			st_Efz_005_000 := TRUE;
			st_Mfz_001 := FALSE;
			op_1_001 := FALSE;
			op_1_010 := FALSE;
			st_Mfz_002 := FALSE;
			op_2_002 := FALSE;
			op_2_006 := FALSE;
			st_Mfz_003 := FALSE;
			op_3_003 := FALSE;
			op_3_007 := FALSE;
			st_Mfz_004 := FALSE;
			op_4_004 := FALSE;
			op_4_008 := FALSE;
			st_Efz_006_005 := FALSE;
			st_Efz_007_009 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF NOT StartConv AND NOT TRUCK_ON_RAMP
		THEN STATE := 005;st_Efz_005_000 := TRUE;
	END_IF
	IF StartConv
	THEN op_2_002 := TRUE;
	END_IF
	IF op_2_002
	THEN STATE := 002;st_Mfz_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_000 OR st_Mfz_002
	 THEN st_Mfz_001 := FALSE;
	op_1_001 := FALSE;
	op_1_010 := FALSE;
	END_IF
	002: IF End_RUN_IN
		THEN op_3_003 := TRUE;
	END_IF
	IF op_3_003
	THEN STATE := 003;st_Mfz_003 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Mfz_003
	 THEN st_Mfz_002 := FALSE;
	op_2_002 := FALSE;
	op_2_006 := FALSE;
	END_IF
	003: IF CONTROL AND NOT BIN_EMPTY AND NOT TRUCK_ON_RAMP OR NOT CONTROL
		THEN STATE := 005;st_Efz_005_000 := TRUE;
	END_IF
	IF CONTROL AND BIN_EMPTY
	THEN op_4_004 := TRUE;
	END_IF
	IF op_4_004
	THEN STATE := 004;st_Mfz_004 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_000 OR st_Mfz_004
	 THEN st_Mfz_003 := FALSE;
	op_3_003 := FALSE;
	op_3_007 := FALSE;
	END_IF
	004: IF EndRunOut OR(NOT EndRunOut AND NOT TRUCK_ON_RAMP)
		THEN STATE := 005;st_Efz_005_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_000
	 THEN st_Mfz_004 := FALSE;
	op_4_004 := FALSE;
	op_4_008 := FALSE;
	END_IF
	005: IF CONTROL AND NOT TRUCK_ON_RAMP AND LAMP_TEST
		THEN STATE := 006;st_Efz_006_005 := TRUE;
	END_IF
	IF NOT CONTROL AND LAMP_TEST
	THEN STATE := 007;st_Efz_007_009 := TRUE;
	END_IF
	IF CONTROL AND TRUCK_ON_RAMP
	THEN op_1_001 := TRUE;
	END_IF
	IF op_1_001
	THEN STATE := 001;st_Mfz_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_006_005 OR st_Efz_007_009 OR st_Mfz_001
	 THEN st_Efz_005_000 := FALSE;
	END_IF
	006: IF NOT LAMP_TEST
		THEN STATE := 005;st_Efz_005_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_000
	 THEN st_Efz_006_005 := FALSE;
	END_IF
	007: IF NOT LAMP_TEST
		THEN STATE := 005;st_Efz_005_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_000
	 THEN st_Efz_007_009 := FALSE;
	END_IF
	END_CASE
		(* Output precalculation *)
	IF NOT op_1_001 THEN  
	CASE STATE OF
	001: op_1_001 := NOT StartConv AND TRUCK_ON_RAMP AND NOT JOG_PB;
		op_1_010 := NOT StartConv AND TRUCK_ON_RAMP AND JOG_PB;
		002: op_2_002 := NOT End_RUN_IN AND NOT BLINK;
			op_2_006 := NOT End_RUN_IN AND BLINK;
			003: op_3_003 := CONTROL AND NOT BIN_EMPTY AND TRUCK_ON_RAMP AND NOT BLINK;
				op_3_007 := CONTROL AND NOT BIN_EMPTY AND TRUCK_ON_RAMP AND BLINK;
				004: op_4_004 := NOT EndRunOut AND TRUCK_ON_RAMP AND NOT BLINK;
	op_4_008 := NOT EndRunOut AND TRUCK_ON_RAMP AND BLINK;
	END_CASE;
	ELSEIF ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	RunInTim := op_2_002 OR op_2_006;
	DUMP_BIN := op_3_003 OR op_3_007;
	CONVEYOR_MOTOR := op_1_010 OR op_2_002 OR op_2_006 OR op_3_003 OR op_3_007
	 OR op_4_004 OR op_4_008;
	RunOutTim := op_4_004 OR op_4_008;
	CONVEYOR_LAMP := op_2_006 OR op_3_007 OR op_4_008;
	Conv_Stopped := st_Efz_005_000;
	TRUCK_LAMP := op_1_001 OR op_2_002 OR op_2_006 OR op_3_003 OR op_3_007
	 OR op_4_004 OR op_4_008 OR st_Efz_006_005 OR st_Efz_007_009;
		(* The post-state-machine list *)
	RUN_IN_Timer(IN:=RunInTim,PT:=RUN_IN_Value);
	RUN_OUT_Timer(IN:=RunOutTim,PT:=RUN_OUT_Value);

END_FUNCTION_BLOCK


FUNCTION_BLOCK  BIN_Control
{ DATE & TIME :  27.04.2006 11:22:01 }
{ VERSION : 1.4 }
VAR_INPUT
BIN_EMPTY : BOOL; (*Bin is empty*)
CONTROL : BOOL; (*Control On*)
DUMP_BIN : BOOL; (*Begin Dump Bin  Really*)
LOAD_PB : BOOL; (*Dump Bin Launch, LOAD pressed*)
END_VAR
VAR_OUTPUT
BIN_VALVE : BOOL; (*Open Bin Valve*)
StartConv : BOOL; (*Conveyor On*)
END_VAR
VAR
FirstRun : BOOL := true; (*Erstlaufkennung*)
st_Efz_001_000 : BOOL; (*Zustand 001 als Efz Operation 000*)
st_Efz_002_002 : BOOL; (*Zustand 002 als Efz Operation 002*)
st_Efz_003_003 : BOOL; (*Zustand 003 als Efz Operation 003*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Efz_001_000 := TRUE;
			st_Efz_002_002 := FALSE;
			st_Efz_003_003 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF CONTROL AND LOAD_PB
		THEN STATE := 002;st_Efz_002_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_002
	 THEN st_Efz_001_000 := FALSE;
	END_IF
	002: IF NOT DUMP_BIN AND NOT CONTROL
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
	IF DUMP_BIN
	THEN STATE := 003;st_Efz_003_003 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000 OR st_Efz_003_003
	 THEN st_Efz_002_002 := FALSE;
	END_IF
	003: IF NOT BIN_EMPTY AND NOT CONTROL OR BIN_EMPTY
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000
	 THEN st_Efz_003_003 := FALSE;
	END_IF
	END_CASE
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	StartConv := st_Efz_002_002 OR st_Efz_003_003;
	BIN_VALVE := st_Efz_003_003;

END_FUNCTION_BLOCK


FUNCTION_BLOCK  SILO
{ DATE & TIME :  27.04.2006 11:22:01 }
{ VERSION : 1.4 }
VAR_INPUT
BLINK : BOOL; (*Blink*)
FILL_BIN : BOOL; (*FILL BIN*)
LAMP_TEST : BOOL; (*Lamp Test Pressed*)
SILO_EMPTY_LS : BOOL; (*Silo Empty*)
SIREN_ACK : BOOL; (*Siren Acknowledge*)
SilentTimerValue : TIME; (*Timer Value Initiation*)
END_VAR
VAR_OUTPUT
SILO_EMPTY_LAMP : BOOL; (*Silo Empty Lamp*)
SILO_VALVE : BOOL; (*Silo Valve Open*)
SIREN : BOOL; (*Siren on*)
END_VAR
VAR
EndSilTim : BOOL; (*Silent Time Over*)
SilTimOn : BOOL; (*Silent Timer*)
FirstRun : BOOL := true; (*Erstlaufkennung*)
st_Mfz_001 : BOOL; (*Zustand 001 als Mfz*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
op_1_003 : BOOL; (*Operation 003 in Mfz 1*)
st_Mfz_002 : BOOL; (*Zustand 002 als Mfz*)
op_2_001 : BOOL; (*Operation 001 in Mfz 2*)
op_2_004 : BOOL; (*Operation 004 in Mfz 2*)
st_Efz_003_005 : BOOL; (*Zustand 003 als Efz Operation 005*)
st_Efz_004_006 : BOOL; (*Zustand 004 als Efz Operation 006*)
st_Efz_005_007 : BOOL; (*Zustand 005 als Efz Operation 007*)
SilentTimer : TON; (*Timer Variable Initiation*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	EndSilTim  :=  SilentTimer.Q;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Mfz_001 := TRUE;
			op_1_000 := TRUE;
			op_1_002 := FALSE;
			op_1_003 := FALSE;
			st_Mfz_002 := FALSE;
			op_2_001 := FALSE;
			op_2_004 := FALSE;
			st_Efz_003_005 := FALSE;
			st_Efz_004_006 := FALSE;
			st_Efz_005_007 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF NOT LAMP_TEST AND SILO_EMPTY_LS AND BLINK
		THEN op_2_001 := TRUE;
	END_IF
	IF NOT LAMP_TEST AND SILO_EMPTY_LS AND NOT BLINK
	THEN op_2_004 := TRUE;
	END_IF
	IF op_2_001 OR op_2_004
	THEN STATE := 002;st_Mfz_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Mfz_002
	 THEN st_Mfz_001 := FALSE;
	op_1_000 := FALSE;
	op_1_002 := FALSE;
	op_1_003 := FALSE;
	END_IF
	002: IF SIREN_ACK
		THEN STATE := 003;st_Efz_003_005 := TRUE;
	END_IF
	IF NOT SIREN_ACK AND(LAMP_TEST OR NOT SILO_EMPTY_LS)
	THEN STATE := 001;st_Mfz_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_003_005 OR st_Mfz_001
	 THEN st_Mfz_002 := FALSE;
	op_2_001 := FALSE;
	op_2_004 := FALSE;
	END_IF
	003: IF EndSilTim
		THEN STATE := 005;st_Efz_005_007 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_007
	 THEN st_Efz_003_005 := FALSE;
	END_IF
	004: IF NOT BLINK
		THEN STATE := 005;st_Efz_005_007 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_005_007
	 THEN st_Efz_004_006 := FALSE;
	END_IF
	005: IF SILO_EMPTY_LS AND BLINK
		THEN STATE := 004;st_Efz_004_006 := TRUE;
	END_IF
	IF NOT SILO_EMPTY_LS
	THEN op_1_000 := TRUE;
	END_IF
	IF op_1_000
	THEN STATE := 001;st_Mfz_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_004_006 OR st_Mfz_001
	 THEN st_Efz_005_007 := FALSE;
	END_IF
	END_CASE
		(* Output precalculation *)
	IF NOT op_1_000 THEN  
	CASE STATE OF
	001: op_1_000 := NOT LAMP_TEST AND NOT SILO_EMPTY_LS AND NOT FILL_BIN;
		op_1_003 := LAMP_TEST;
		op_1_002 := NOT LAMP_TEST AND NOT SILO_EMPTY_LS AND FILL_BIN;
		002: op_2_001 := NOT SIREN_ACK AND NOT LAMP_TEST AND SILO_EMPTY_LS AND BLINK;
			op_2_004 := NOT SIREN_ACK AND NOT LAMP_TEST AND SILO_EMPTY_LS AND NOT BLINK;
		END_CASE;
		ELSEIF ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	SILO_VALVE := op_1_002;
	SilTimOn := st_Efz_003_005;
	SIREN := op_2_001 OR op_2_004 OR st_Efz_003_005;
	SILO_EMPTY_LAMP := op_1_003 OR op_2_001 OR st_Efz_003_005 OR st_Efz_004_006;
		(* The post-state-machine list *)
	SilentTimer(IN:=SilTimOn,PT:=SilentTimerValue);

END_FUNCTION_BLOCK


FUNCTION_BLOCK  BLINK_BLANK
{ DATE & TIME :  27.04.2006 11:22:01 }
{ VERSION : 1.4 }
VAR_OUTPUT
BLINK : BOOL; (*Blink Output*)
END_VAR
VAR
BLANK_PASSED : BOOL; (*Blank is over*)
BLINK_PASSED : BOOL; (*Blink is over*)
BlankOn : BOOL; (*Blank Timer On*)
BlinkOn : BOOL; (*BlinkTimer*)
FirstRun : BOOL := true; (*Erstlaufkennung*)
st_Efz_001_000 : BOOL; (*Zustand 001 als Efz Operation 000*)
st_Efz_002_001 : BOOL; (*Zustand 002 als Efz Operation 001*)
BLINKTimer : TON; (*Timer Variable Initiation*)
BLANKTimer : TON; (*Timer Variable Initiation*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	BLANK_PASSED  :=  BLANKTimer.Q;
	BLINK_PASSED  :=  BLINKTimer.Q;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Efz_001_000 := TRUE;
			st_Efz_002_001 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF BLINK_PASSED
		THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_001
	 THEN st_Efz_001_000 := FALSE;
	END_IF
	002: IF BLANK_PASSED
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000
	 THEN st_Efz_002_001 := FALSE;
	END_IF
	END_CASE
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	BlinkOn := st_Efz_001_000;
	BLINK := st_Efz_001_000;
	BlankOn := st_Efz_002_001;
		(* The post-state-machine list *)
	BLANKTimer(IN:=BlankOn,PT:=T#250MS);
	BLINKTimer(IN:=BlinkOn,PT:=T#250MS);

END_FUNCTION_BLOCK


PROGRAM  GRAVEL  (*Hauptprogramm *)
VAR
OK_TO_RUN1 : BOOL; (*Band-Anlauf*)
BinLevel_Equ_SetPoint : BOOL; (*KOP 2 => 1*)
Conv_Ready : BOOL; (*KOP 3 => 1*)
ControlOn : BOOL; (*KOP 1 => 3, 4*)
OK_TO_RUN : BOOL; (*KOP 4 => 3*)
DosBinFill : BOOL; (*KOP 4 => 5*)
DumpBIN : BOOL; (*KOP 3 => 4*)
BLINK : BOOL; (*KOP 6 => 3, 5*)
OFF_PB AT %IX 1 : BOOL;(*HSO 10*)
ON_PB AT %IX 2 : BOOL;(*HSO 10*)
FILL_PB AT %IX 3 : BOOL;(*HSO 10*)
SIREN_ACK AT %IX 4 : BOOL;(*HSO 10*)
LOAD_PB AT %IX 5 : BOOL;(*HSO 10*)
JOG_PB AT %IX 6 : BOOL;(*HSO 10*)
TRUCK_ON_RAMP AT %IX 13 : BOOL;(*GSO 6*)
SILO_EMPTY_LS AT %IX 14 : BOOL;(*LASO L 2*)
BIN_EMPTY_LS AT %IX 15 : BOOL;(*LISO L 4*)
LAMP_TEST AT %IX 8 : BOOL;(*HSO 10*)
SETPOINT AT %IW 3 : WORD;(*HSO 10*)
CONTROL_LAMP AT %QX 33 : BOOL;(*HSO 10*)
TRUCK_LAMP AT %QX 35 : BOOL;(*GSO 6*)
SILO_EMPTY_LAMP AT %QX 36 : BOOL;(*LASO L 2*)
CONVEYOR_LAMP AT %QX 44 : BOOL;(*EUO 5*)
CONVEYOR_MOTOR AT %QX 45 : BOOL;(*EUO 5*)
SILO_VALVE AT %QX 46 : BOOL;(*UV 1*)
BIN_VALVE AT %QX 47 : BOOL;(*UV 3*)
SIREN AT %QX 48 : BOOL;(*LASO L 2*)
BIN_LEVEL AT %QW 7 : WORD;(*LSIO L 4*)
HMI_CONTROL_1 : HMI_Control; (*Man Machine Control*)
BIN_VOLUME_2 : BIN_Volume; (*Simulation on Bin Level by Counting*)
CONVEYOR_3 : CONVEYOR_MOTOR; (*Conveyor Control on Motor and Alarm Mamagement*)
BIN_CONTROL_4 : BIN_Control; (*Bin Control on Valve*)
SILO_5 : SILO; (*Silo Control on empty*)
BLINK_BLANK_6 : BLINK_BLANK; (*Blink Beat*)
END_VAR
VAR_EXTERNAL
InitVar_1 : BOOL; (*Init-Variable TP1*)
InitVar_2 : BOOL; (*Init-Variable TP2*)
InitVar_3 : BOOL; (*Init-Variable TP3*)
InitVar_4 : BOOL; (*Init-Variable TP4*)
InitVar_5 : BOOL; (*Init-Variable TP5*)
END_VAR

HMI_CONTROL_1(
BIN_LEVEL_EQU_SET_POINT := BinLevel_Equ_SetPoint,
FILL_PB := FILL_PB,
LAMP_TEST := LAMP_TEST,
OFF_PB := OFF_PB,
ON_PB := ON_PB,
TRUCK_LOADED := Conv_Ready,
BIN_LEVEL := BIN_LEVEL,
CONTROL => ControlOn,
CtrlLamp => CONTROL_LAMP,
Fill_Bin => DosBinFill,
FirstRun := InitVar_1);

BIN_VOLUME_2(
Dump_Bin_Begin := DumpBIN,
FILL_Begin := DosBinFill,
SET_POINT := SETPOINT,
BIN_LEVEL => BIN_LEVEL,
BinLevel_Equ_SP := BinLevel_Equ_SetPoint,
FirstRun := InitVar_2);

CONVEYOR_3(
BIN_EMPTY := BIN_EMPTY_LS,
BLINK := BLINK,
CONTROL := ControlOn,
JOG_PB := JOG_PB,
LAMP_TEST := LAMP_TEST,
StartConv := OK_TO_RUN,
TRUCK_ON_RAMP := TRUCK_ON_RAMP,
RUN_IN_Value := T#05S000MS,
RUN_OUT_Value := T#25S000MS,
CONVEYOR_LAMP => CONVEYOR_LAMP,
CONVEYOR_MOTOR => CONVEYOR_MOTOR,
Conv_Stopped => Conv_Ready,
DUMP_BIN => DumpBIN,
TRUCK_LAMP => TRUCK_LAMP,
FirstRun := InitVar_3);

BIN_CONTROL_4(
BIN_EMPTY := BIN_EMPTY_LS,
CONTROL := ControlOn,
DUMP_BIN := DumpBIN,
LOAD_PB := LOAD_PB,
BIN_VALVE => BIN_VALVE,
StartConv => OK_TO_RUN,
FirstRun := InitVar_4);

SILO_5(
BLINK := BLINK,
FILL_BIN := DosBinFill,
LAMP_TEST := LAMP_TEST,
SILO_EMPTY_LS := SILO_EMPTY_LS,
SIREN_ACK := SIREN_ACK,
SilentTimerValue := T#05S000MS,
SILO_EMPTY_LAMP => SILO_EMPTY_LAMP,
SILO_VALVE => SILO_VALVE,
SIREN => SIREN,
FirstRun := InitVar_5);

BLINK_BLANK_6(
BLINK => BLINK);

END_PROGRAM


CONFIGURATION  Schuettgut

RESOURCE PROC1 ON undecided  (*Steuerung des Schttgutprozesses*)
VAR_GLOBAL
InitVar_1 : BOOL; (*Init-Variable TP1*)
InitVar_2 : BOOL; (*Init-Variable TP2*)
InitVar_3 : BOOL; (*Init-Variable TP3*)
InitVar_4 : BOOL; (*Init-Variable TP4*)
InitVar_5 : BOOL; (*Init-Variable TP5*)
END_VAR
TASK  Task_1(INTERVAL := 0, PRIORITY:= 30);
TASK  Task_2(SINGLE := PROC1, PRIORITY:= 1);
 Program_Instance_2  WITH Task_2: Anlauf;
 Program_Instance_1  WITH Task_1: GRAVEL;
END_RESOURCE

END_CONFIGURATION
