FUNCTION_BLOCK  HandBetrieb
{ DATE & TIME :  19.02.2007 14:53:31 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_op_1_000 : INT := 0; (*Operation 000 in Mfz 1*)
Const_op_1_001 : INT := 1; (*Operation 001 in Mfz 1*)
Const_op_1_002 : INT := 2; (*Operation 002 in Mfz 1*)
END_VAR
VAR_INPUT
KeinAutom : BOOL; (*Handsteuerung erlaubt*)
TorOben : BOOL; (*Tor geffnet*)
TorUnten : BOOL; (*Tor ge- schlossen*)
VHdOeff : BOOL; (*Tor von Hand ffnen*)
VHdSchli : BOOL; (*Tor von Hand schlieen*)
END_VAR
VAR_OUTPUT
TorOeffHd : BOOL; (*Tor ffnen (Hd)*)
TorSchlHd : BOOL; (*Tor schlieen (Hd)*)
END_VAR
VAR
FirstRun : BOOL := TRUE; (*Erstlaufkennung*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
OldOperationINT : INT := 2; (*Alte Operationscodierung*)
OperationINT : INT := 2; (*Operationscodierung*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial operation *)
	IF FirstRun THEN ;
			op_1_002 := TRUE;
			op_1_000 := FALSE;
			op_1_001 := FALSE;
	END_IF
		(* Output precalculation *)
	IF NOT FirstRun THEN 
	op_1_000 := KeinAutom AND VHdOeff AND NOT TorOben;
	op_1_002 := KeinAutom AND(VHdOeff AND TorOben OR(NOT VHdOeff AND(NOT VHdSchli
	 OR TorUnten))) OR(NOT KeinAutom);
	op_1_001 := KeinAutom AND NOT VHdOeff AND VHdSchli AND NOT TorUnten;
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	TorOeffHd := op_1_000;
	TorSchlHd := op_1_001;
		(* The post-state-machine list *)
	IF op_1_000
	THEN OperationINT  :=  0;
	END_IF
	IF op_1_001
	THEN OperationINT  :=  1;
	END_IF
	IF op_1_002
	THEN OperationINT  :=  2;
	END_IF

END_FUNCTION_BLOCK


FUNCTION_BLOCK  Automatik
{ DATE & TIME :  19.02.2007 14:53:31 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_st_Efz_001_000 : INT := 0; (*Zustand 001 als Efz Operation 000*)
Const_st_Efz_002_001 : INT := 1; (*Zustand 002 als Efz Operation 001*)
Const_st_Efz_003_002 : INT := 2; (*Zustand 003 als Efz Operation 002*)
Const_st_Efz_004_003 : INT := 3; (*Zustand 004 als Efz Operation 003*)
END_VAR
VAR_INPUT
FahrzAusgef : BOOL; (*Fahrzeug aus Torbereich ausgefahren*)
FahrzEingef : BOOL; (*Fahrzeug in Torbereich eingefahren*)
TorOben : BOOL; (*Tor geffnet*)
TorOeffVHd : BOOL; (*Tor von Hand ffnen*)
TorUnten : BOOL; (*Tor geschlossen*)
END_VAR
VAR_OUTPUT
FahrzAusf : BOOL; (*Fahrzeug START*)
HandStgFrei : BOOL; (*Handsteuerung freigegeben*)
TorOeffAut : BOOL; (*Tor ffnen (AUT)*)
TorSchlAut : BOOL; (*Tor schlieen (AUT)*)
END_VAR
VAR
FirstRun : BOOL := TRUE; (*Erstlaufkennung*)
st_Efz_001_000 : BOOL; (*Zustand 001 als Efz Operation 000*)
st_Efz_002_001 : BOOL; (*Zustand 002 als Efz Operation 001*)
st_Efz_003_002 : BOOL; (*Zustand 003 als Efz Operation 002*)
st_Efz_004_003 : BOOL; (*Zustand 004 als Efz Operation 003*)
OldOperationINT : INT := 0; (*Alte Operationscodierung*)
OperationINT : INT := 0; (*Operationscodierung*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Efz_001_000 := TRUE;
			st_Efz_002_001 := FALSE;
			st_Efz_003_002 := FALSE;
			st_Efz_004_003 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF FahrzEingef AND NOT TorOben
		THEN STATE := 002;st_Efz_002_001 := TRUE;
	END_IF
	IF FahrzEingef AND TorOben
	THEN STATE := 003;st_Efz_003_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_002_001 OR st_Efz_003_002
	 THEN st_Efz_001_000 := FALSE;
	END_IF
	002: IF TorOben
		THEN STATE := 003;st_Efz_003_002 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_003_002
	 THEN st_Efz_002_001 := FALSE;
	END_IF
	003: IF FahrzAusgef
		THEN STATE := 004;st_Efz_004_003 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_004_003
	 THEN st_Efz_003_002 := FALSE;
	END_IF
	004: IF NOT TorOeffVHd AND TorUnten OR TorOeffVHd
		THEN STATE := 001;st_Efz_001_000 := TRUE;
	END_IF
		(* Bit-Code change *)
	IF st_Efz_001_000
	 THEN st_Efz_004_003 := FALSE;
	END_IF
	END_CASE
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	HandStgFrei := st_Efz_001_000;
	TorOeffAut := st_Efz_002_001;
	FahrzAusf := st_Efz_003_002;
	TorSchlAut := st_Efz_004_003;
		(* The post-state-machine list *)
	IF st_Efz_001_000
	THEN OperationINT  :=  0;
	END_IF
	IF st_Efz_002_001
	THEN OperationINT  :=  1;
	END_IF
	IF st_Efz_003_002
	THEN OperationINT  :=  2;
	END_IF
	IF st_Efz_004_003
	THEN OperationINT  :=  3;
	END_IF

END_FUNCTION_BLOCK


FUNCTION_BLOCK  Antrieb
{ DATE & TIME :  19.02.2007 14:53:32 }
{ VERSION : 1.4 }
VAR CONSTANT
Const_op_1_000 : INT := 0; (*Operation 000 in Mfz 1*)
Const_op_1_001 : INT := 1; (*Operation 001 in Mfz 1*)
Const_op_1_002 : INT := 2; (*Operation 002 in Mfz 1*)
END_VAR
VAR_INPUT
TorAbVHd : BOOL; (*Tor abwrts von Hand*)
TorAbwAut : BOOL; (*Tor abwrts automatisch*)
TorAufwAut : BOOL; (*Tor aufwrts automatisch*)
TorAufwVHd : BOOL; (*Tor aufwrts von Hand*)
END_VAR
VAR_OUTPUT
TorMotAbw : BOOL; (*Tormotor abwrts*)
TorMotAufw : BOOL; (*Tormotor aufwrts*)
END_VAR
VAR
FirstRun : BOOL := TRUE; (*Erstlaufkennung*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
OldOperationINT : INT := 2; (*Alte Operationscodierung*)
OperationINT : INT := 2; (*Operationscodierung*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial operation *)
	IF FirstRun THEN ;
			op_1_002 := TRUE;
			op_1_000 := FALSE;
			op_1_001 := FALSE;
	END_IF
		(* Output precalculation *)
	IF NOT FirstRun THEN 
	op_1_000 := NOT TorAufwVHd AND TorAufwAut OR TorAufwVHd;
	op_1_002 := NOT TorAufwVHd AND NOT TorAufwAut AND NOT TorAbVHd AND NOT TorAbwAut;
	op_1_001 := NOT TorAufwAut AND NOT TorAufwVHd AND(TorAbwAut OR TorAbVHd
	);
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	TorMotAufw := op_1_000;
	TorMotAbw := op_1_001;
		(* The post-state-machine list *)
	IF op_1_000
	THEN OperationINT  :=  0;
	END_IF
	IF op_1_001
	THEN OperationINT  :=  1;
	END_IF
	IF op_1_002
	THEN OperationINT  :=  2;
	END_IF

END_FUNCTION_BLOCK


PROGRAM  Program_1  (*Bearbeitung der Torsteuerung*)
VAR
HandStgFrei : BOOL; (*Handsteuerung freigegeben*)
TorOeffHd : BOOL; (*Tor ffnen: Handsteuerung*)
TorSchlHd : BOOL; (*Tor schlieen: Handsteuerung*)
TorOeffAut : BOOL; (*Tor ffnen: Automatiksteuerung*)
TorSchlAut : BOOL; (*Tor schlieen: Automatiksteuerung*)
FahrzeugAusgef AT %IX 6 : BOOL;(**)
FahrzeugEingef AT %IX 5 : BOOL;(**)
TorGeschl AT %IX 4 : BOOL;(**)
TorOffen AT %IX 3 : BOOL;(**)
VHdNachUnten AT %IX 2 : BOOL;(**)
VHdNachOben AT %IX 1 : BOOL;(**)
FahrzeugAbfahren AT %QX 11 : BOOL;(**)
TorOeffnen AT %QX 9 : BOOL;(**)
TorSCHliessen AT %QX 10 : BOOL;(**)
HandBetr_1 : HandBetrieb; (**)
Automatik_2 : Automatik; (*Automaitische Torsteuerung*)
Antrieb_3 : Antrieb; (*Tor-Motor-Steuerung*)
END_VAR

HandBetr_1(
KeinAutom := HandStgFrei,
TorOben := TorOffen,
TorUnten := TorGeschl,
VHdOeff := VHdNachOben,
VHdSchli := VHdNachUnten);
TorOeffHd := HandBetr_1.TorOeffHd;
TorSchlHd := HandBetr_1.TorSchlHd;

Automatik_2(
FahrzAusgef := FahrzeugAusgef,
FahrzEingef := FahrzeugEingef,
TorOben := TorOffen,
TorOeffVHd := VHdNachOben,
TorUnten := TorGeschl);
FahrzeugAbfahren := Automatik_2.FahrzAusf;
HandStgFrei := Automatik_2.HandStgFrei;
TorOeffAut := Automatik_2.TorOeffAut;
TorSchlAut := Automatik_2.TorSchlAut;

Antrieb_3(
TorAbVHd := TorSchlHd,
TorAbwAut := TorSchlAut,
TorAufwAut := TorOeffAut,
TorAufwVHd := VHdNachOben);
TorSCHliessen := Antrieb_3.TorMotAbw;
TorOeffnen := Antrieb_3.TorMotAufw;

END_PROGRAM


RESOURCE Resource ON PROCESSOR 1  (*global Member of Resource*)
TASK  Task_1(INTERVAL := 0, PRIORITY:= 1);
 Program_1_Inst  WITH Task_1: Program_1;
END_RESOURCE


