FUNCTION_BLOCK  TorStrg
{ DATE & TIME :  12.02.2005 11:09:39 }
{ VERSION : 1.3 }
VAR_INPUT
FahrzEingefahren : BOOL := formal; (*Fahrzeug in den Torbereich eingefahren*)
TorTastOeffn : BOOL := formal; (*Tor von Hand ffnen*)
TorTastSchlie : BOOL := formal; (*Tor von Hand schlieen*)
TorGeoeff : BOOL := formal; (*Tor geffnet*)
TorGeschl : BOOL := formal; (*Tor geschlossen*)
FahrzeugAus : BOOL := formal; (*Fahrzeug aus dem Torbereich ausgefahren*)
END_VAR
VAR_OUTPUT
TorOeffnen : BOOL := formal; (*Tor ffnen*)
TorSchlie : BOOL := formal; (*Tor schlieen*)
FahrzStart : BOOL := formal; (*Fahrzeug abfahren*)
END_VAR
VAR_IN_OUT
FirstRun : BOOL := true; (*Erstlaufkennung*)
END_VAR
VAR
st_Mfz_001 : BOOL; (*Zustand 001 als Mfz*)
op_1_000 : BOOL; (*Operation 000 in Mfz 1*)
op_1_001 : BOOL; (*Operation 001 in Mfz 1*)
op_1_002 : BOOL; (*Operation 002 in Mfz 1*)
st_Efz_002_003 : BOOL; (*Zustand 002 als Efz Operation 003*)
st_Efz_003_004 : BOOL; (*Zustand 003 als Efz Operation 004*)
st_Efz_004_005 : BOOL; (*Zustand 004 als Efz Operation 005*)
OldOperationINT : INT := 0; (*Alte Operationscodierung*)
OperationINT : INT := 0; (*Operationscodierung*)
STATE : INT := 0; (*Zustands-Nummer*)
END_VAR
		(* The pre-state-machine list *)
	OldOperationINT  :=  OperationINT;
		(* Set the initial state *)
	IF FirstRun THEN STATE := 001;	(* Initial situation *)
			st_Mfz_001 := TRUE;
			op_1_000 := TRUE;
			op_1_001 := FALSE;
			op_1_002 := FALSE;
			st_Efz_002_003 := FALSE;
			st_Efz_003_004 := FALSE;
			st_Efz_004_005 := FALSE;
	END_IF
		(* The state machine *)
	IF NOT FirstRun THEN 
	CASE STATE OF
	001: IF FahrzEingefahren AND TorGeoeff
		THEN STATE := 003;st_Efz_003_004 := TRUE;
		END_IF
		IF FahrzEingefahren AND NOT TorGeoeff
		THEN STATE := 002;st_Efz_002_003 := TRUE;
		END_IF
			(* Code change *)
		IF st_Efz_003_004 OR st_Efz_002_003 THEN 
			st_Mfz_001 := FALSE;
			op_1_000 := FALSE;
			op_1_001 := FALSE;
			op_1_002 := FALSE;
		END_IF
	002: IF TorGeoeff
		THEN STATE := 003;st_Efz_003_004 := TRUE;
		END_IF
			(* Code change *)
		IF st_Efz_003_004 THEN 
			st_Efz_002_003 := FALSE;
		END_IF
	003: IF FahrzeugAus
		THEN STATE := 004;st_Efz_004_005 := TRUE;
		END_IF
			(* Code change *)
		IF st_Efz_004_005 THEN 
			st_Efz_003_004 := FALSE;
		END_IF
	004: IF NOT TorTastOeffn AND TorGeschl
		THEN op_1_000 := TRUE;
		END_IF
		IF TorTastOeffn
		THEN op_1_002 := TRUE;
		END_IF
		IF op_1_000 OR op_1_002
		THEN STATE := 001;st_Mfz_001 := TRUE;
		END_IF
			(* Code change *)
		IF st_Mfz_001 THEN 
			st_Efz_004_005 := FALSE;
		END_IF
	END_CASE
		(* Output precalculation *)
	IF NOT op_1_000 THEN  
	CASE STATE OF
	001: IF NOT FahrzEingefahren AND(TorTastOeffn AND TorGeoeff OR(NOT TorTastOeffn
		 AND(TorGeschl OR NOT TorTastSchlie)))
		THEN op_1_000 := TRUE; ELSE op_1_000 := FALSE;
		END_IF
		IF NOT FahrzEingefahren AND NOT TorTastOeffn AND TorTastSchlie AND NOT TorGeschl
		THEN op_1_001 := TRUE; ELSE op_1_001 := FALSE;
		END_IF
		IF NOT FahrzEingefahren AND TorTastOeffn AND NOT TorGeoeff
		THEN op_1_002 := TRUE; ELSE op_1_002 := FALSE;
		END_IF
	END_CASE;
	END_IF
	ELSE  FirstRun := False;
	END_IF
		(* The output list *)
	IF op_1_002 OR st_Efz_002_003
	THEN TorOeffnen := TRUE; ELSE TorOeffnen := FALSE;
	END_IF
	IF st_Efz_003_004
	THEN FahrzStart := TRUE; ELSE FahrzStart := FALSE;
	END_IF
	IF op_1_001 OR st_Efz_004_005
	THEN TorSchlie := TRUE; ELSE TorSchlie := FALSE;
	END_IF
		(* The post-state-machine list *)
	IF op_1_000
	THEN OperationINT  :=  0;
	END_IF
	IF op_1_001
	THEN OperationINT  :=  1;
	END_IF
	IF op_1_002
	THEN OperationINT  :=  2;
	END_IF
	IF st_Efz_002_003
	THEN OperationINT  :=  3;
	END_IF
	IF st_Efz_003_004
	THEN OperationINT  :=  4;
	END_IF
	IF st_Efz_004_005
	THEN OperationINT  :=  5;
	END_IF

END_FUNCTION_BLOCK


PROGRAM  Program_1  (*Hauptprogramm*)
VAR
FahrzeugAusgef AT %IX 6 : BOOL;(**)
FahrzeugEingef AT %IX 5 : BOOL;(**)
TorGeschl AT %IX 4 : BOOL;(**)
TorOffen AT %IX 3 : BOOL;(**)
VHdNachUnten AT %IX 2 : BOOL;(**)
VHdnachOben AT %IX 1 : BOOL;(**)
FahrzeugABfahren AT %QX 11 : BOOL;(**)
TorOEffnen AT %QX 9 : BOOL;(**)
TorSCHliessen AT %QX 10 : BOOL;(**)
TorGesamt : TorStrg;(*Tor in einem TP*)
END_VAR

 TorGesamt(
FahrzEingefahren := FahrzeugEingef,
TorTastOeffn := VHdnachOben,
TorTastSchlie := VHdNachUnten,
TorGeoeff := TorOffen,
TorGeschl := TorGeschl,
FahrzeugAus := FahrzeugAusgef,
TorOeffnen := TorOEffnen,
TorSchlie := TorSCHliessen,
FahrzStart := FahrzeugABfahren
);
END_PROGRAM


RESOURCE Resource ON   (*global Member of Resource*)
TASK  Task_1(INTERVAL := 0, PRIORITY:= 1);
 Program_1_Inst  WITH Task_1: Program_1;
END_RESOURCE

